package com.junmp.print.app;


import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.util.SPUtil;
import com.junmp.print.util.UIUtil;

/**
 * <pre>
 * 描述：设置用户相关的缓存
 * 版本：1.0
 * 日期：2017/8/24
 * 作者：ningzp@junmp.com.cn
 * </pre>
 */

public class UserCache {

    /**
     * 获取缓存的用户工号
     */
    public static String getUserNo() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.USER_NO, "");
    }

    /**
     * 获取缓存的用户名
     */
    public static String getName() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.NAME, "");
    }


    /**
     * 获取缓存的用户token
     */
    public static String getPassWord() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.PASSWORD, "");
    }

    /**
     * 获取缓存的用户id
     */
    public static Long getId() {
        return SPUtil.getInstance(UIUtil.getContext()).getLong(AppConstants.User.ID, 0l);
    }

    /**
     * 获取缓存的设备天线功率antPower   默认25
     */
    public static Integer getAntPower() {
        return SPUtil.getInstance(UIUtil.getContext()).getInt(AppConstants.User.ANTPOWER, 25);
    }

    /**
     * 设置设备天线功率antPower位置缓存
     *
     * @param antPower
     */
    public static void saveAntPower(Integer antPower) {
        SPUtil.getInstance(UIUtil.getContext()).putInt(AppConstants.User.ANTPOWER, antPower);
    }



    /**
     * 获取缓存的是否锁定校验物资
     */
    public static String getIsjysd() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.ISJYSD, "");
    }


    /**
     * 获取缓存的是否锁定校验物资号型
     */
    public static String getIsjysdhx() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.ISJYSDHX, "");
    }


    /**
     * 获取缓存的物资号型名称
     */
    public static String getStrWzhxName() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.STRWZHXNAME, "");
    }



    /**
     * 获取缓存的物资名称
     */
    public static String getStrWzName() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.STRWZNAME, "");
    }



    /**
     * 获取缓存的物资代码
     */
    public static String getStrWzdm() {
        return SPUtil.getInstance(UIUtil.getContext()).getString(AppConstants.User.STRWZDM, "");
    }


    /**
     * 设置登录用户缓存
     *
     * @param jpTabConfig
     */
    public static void save(JpTabConfig jpTabConfig) {
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.NAME, jpTabConfig.getStruser());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.PASSWORD, jpTabConfig.getStrpass());
        SPUtil.getInstance(UIUtil.getContext()).putLong(AppConstants.User.ID, jpTabConfig.getId());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.ISJYSD, jpTabConfig.getIsjysd());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.ISJYSDHX, jpTabConfig.getIsjysdhx());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.STRWZHXNAME, jpTabConfig.getStrwzhxname());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.STRWZNAME, jpTabConfig.getStrwzname());
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.STRWZDM, jpTabConfig.getStrwzdm());
        SPUtil.getInstance(UIUtil.getContext()).putInt(AppConstants.User.ANTPOWER, jpTabConfig.getNpower());//0-33
    }


    /**
     * 清除登出用户缓存
     */
    public static void clear() {
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.NAME);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.PASSWORD);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.ID);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.ISJYSD);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.ISJYSDHX);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.STRWZHXNAME);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.STRWZNAME);
        SPUtil.getInstance(UIUtil.getContext()).remove(AppConstants.User.STRWZDM);
    }

    /**
     * 设置登录用户密码
     *
     * @param password
     */
    public static void savePassWord(String password) {
        SPUtil.getInstance(UIUtil.getContext()).putString(AppConstants.User.PASSWORD, password);
    }

}
