package com.junmp.print.dao.service;

import android.database.Cursor;

import com.junmp.print.PrintApplication;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.dao.entity.TabBzglWzdm;
import com.junmp.print.dao.entity.TabBzglWzdmBean;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/31
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class CommonService {

    /**
     *
     */
    public List<TabBzglWzdmBean> getSCCSInfo(String strSCCSCode) {

        List<TabBzglWzdmBean> listBeans = new ArrayList<>();

        try{
            String sql = "select fwdwdm as strcsdm,fwdwmc as strcsmc from " +
                    "(SELECT DWDM AS FWDWDM, DWFH AS FWDWMC, XSLSGX AS YHDM, \n" +
                    "      XSLSXH AS YHXM, XZBZ AS YHKL\n" +
                    "FROM TAB_BZGL_XTBZDW\n" +
                    "WHERE (DWDM LIKE 'D9%'))" +
                    " as d where fwdwdm = '" + strSCCSCode + "'";
            Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery(sql,null);
            //判断游标是否为空
            if(cursor.moveToFirst()) {
                //遍历游标
                for(int i=0;i<cursor.getCount();i++){
                    cursor.move(i);
                    TabBzglWzdmBean bean = new TabBzglWzdmBean();
                    bean.setStrcsdm(cursor.getString(0));
                    bean.setStrcsmc(cursor.getString(1));
                    listBeans.add(bean);
                }
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     *
     */
    public List<TabBzglWzdmBean> getWZHXInfo(String strWzNo) {

        List<TabBzglWzdmBean> listBeans = new ArrayList<>();

        try{
            String sql = "select hxdm as strwzdm,zbqmc as strwzmc,hx as strwzhx,lsm from " +
                    "(SELECT FLDM, LSM, ZBQMC, JLDW, HXLBBSM, HXLBMC, HX, DMLBBM, DMLBMC, \n" +
                    "      WZDM, HXDM, '0' AS ZBSL\n" +
                    "FROM TAB_BZGL_WZDM)" +
                    " as d where hxdm = '" + strWzNo + "'";
            Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery(sql,null);
            //判断游标是否为空
            if(cursor.moveToFirst()) {
                //遍历游标
                for(int i=0;i<cursor.getCount();i++){
                    cursor.move(i);
                    TabBzglWzdmBean bean = new TabBzglWzdmBean();
                    bean.setStrwzdm(cursor.getString(0));
                    bean.setStrwzmc(cursor.getString(1));
                    bean.setStrwzhx(cursor.getString(2));
                    bean.setLsm(cursor.getString(3));
                    listBeans.add(bean);
                }
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 查询所有记录
     */
    public List loadAll() {
        List<TabBzglWzdm> listBeans = new ArrayList<>();
        listBeans =  PrintApplication.getDaoSession().getTabBzglWzdmDao().loadAll();
        return listBeans;
    }

    /**
     *
     */
    public List<TabBzglWzdmBean> getWZHXInfoByLsm(String Lsm) {

        List<TabBzglWzdmBean> listBeans = new ArrayList<>();

        try{
            String sql = "select hxdm as strwzdm,zbqmc as strwzmc,hx as strwzhx,lsm from " +
                    "(SELECT FLDM, LSM, ZBQMC, JLDW, HXLBBSM, HXLBMC, HX, DMLBBM, DMLBMC, \n" +
                    "      WZDM, HXDM, '0' AS ZBSL\n" +
                    "FROM TAB_BZGL_WZDM)" +
                    " as d where lsm = '" + Lsm + "'";
            Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery(sql,null);
            //判断游标是否为空
            if(cursor.moveToFirst()) {
                //遍历游标
                for(int i=0;i<cursor.getCount();i++){
                    cursor.move(i);
                    TabBzglWzdmBean bean = new TabBzglWzdmBean();
                    bean.setStrwzdm(cursor.getString(0));
                    bean.setStrwzmc(cursor.getString(1));
                    bean.setStrwzhx(cursor.getString(2));
                    bean.setLsm(cursor.getString(3));
                    listBeans.add(bean);
                }
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }
}
