package com.junmp.print.dao.service;

import android.database.Cursor;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.dao.db.JpTabFwqdjyDao;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;

import org.greenrobot.greendao.query.DeleteQuery;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/29
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class JpTabFwqdjyService {


    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();

    /**
     * 判断校验记录是否存在
     * @param fwqdjy 校验记录
     * @param byQdh 是否按照清单号查
     */
    public  List<JpTabFwqdjy> isNew(JpTabFwqdjy fwqdjy,boolean byQdh) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            if(byQdh){
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                        .where(JpTabFwqdjyDao.Properties.SubEpc.eq(fwqdjy.getSubEpc()))
                        .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                        .where(JpTabFwqdjyDao.Properties.Qydwdm.eq(fwqdjy.getQydwdm()))
                        .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                        .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqdjy.getQdh())).list();
            }else{
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                        .where(JpTabFwqdjyDao.Properties.SubEpc.eq(fwqdjy.getSubEpc())).list();
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 新增记录
     */
    public boolean insert(JpTabFwqdjy fwqdjy) {
        boolean flag = false;

        try{
            PrintApplication.getDaoSession().getJpTabFwqdjyDao().insert(fwqdjy);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 新增记录(批量)
     */
    public boolean insert(List<JpTabFwqdjy> list) {
        boolean flag = false;

        try{
            PrintApplication.getDaoSession().getJpTabFwqdjyDao().insertInTx(list);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 数据更新
     */
    public boolean updateIsOut(JpTabFwqdjy fwqdjy) {

        boolean flag = false;

        try{

            List<JpTabFwqdjy> listBeans = Lists.newArrayList();
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqdjy.getQdh())).list();
            List<JpTabFwqdjy> listBeansReal = new ArrayList<>();
            for(JpTabFwqdjy beanReal : listBeans){
                beanReal.setIsOk(fwqdjy.getIsOk());
                listBeansReal.add(beanReal);
            }
            PrintApplication.getDaoSession().getJpTabFwqdjyDao()
                    .updateInTx(listBeansReal);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 数据更新
     */
    public boolean update(JpTabFwqdjy fwqdjy) {

        boolean flag = false;

        try{
            String sql = "update jp_tab_fwqdjy set isOk = '"+fwqdjy.getIsOk()+"' ,Dtpdate = '"+fwqdjy.getDtpdate()+"',Strepc = case when length(Strepc)>5 then Strepc else '"+fwqdjy.getStrepc()+"' end,\n" +
                    "   Strepc1 = case when length(Strepc1)>5 then Strepc1 else '"+fwqdjy.getStrepc1()+"' end,\n" +
                    "Strepc2 = case when length(Strepc2)>5 then Strepc2 else '"+fwqdjy.getStrepc2()+"' end,\n" +
                    "Strepc3 = case when length(Strepc3)>5 then Strepc3 else '"+fwqdjy.getStrepc3()+"' end\n" +
                    "where subEpc = '"+fwqdjy.getSubEpc()+"'\n" +
                    "and Gznd = '"+fwqdjy.getGznd()+"'\n" +
                    "and Qydwdm = '"+fwqdjy.getQydwdm()+"'\n" +
                    "and Ysjhbh = '"+fwqdjy.getYsjhbh()+"'\n" +
                    "and Qdh = '"+fwqdjy.getQdh()+"'";
            PrintApplication.getDaoSession().getDatabase().execSQL(sql);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 批量删除
     */
    public boolean deleteByLsm(List<JpTabFwqdjy> list) {

        boolean flag = false;

        try{

            List<JpTabFwqdjy> listOld = Lists.newArrayList();
            for(JpTabFwqdjy bean : list){
                List<JpTabFwqdjy> listBeans = Lists.newArrayList();
                listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                        .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                        .where(JpTabFwqdjyDao.Properties.Qdh.eq(bean.getQdh()))
                        .where(JpTabFwqdjyDao.Properties.Lsm.eq(bean.getLsm()))
                        .where(JpTabFwqdjyDao.Properties.Swdwdm.eq(bean.getSwdwdm()))
                        .where(JpTabFwqdjyDao.Properties.Jsdwdm.eq(bean.getJsdwdm())).list();
                listOld.addAll(listBeans);
            }
            PrintApplication.getDaoSession().getJpTabFwqdjyDao()
                    .deleteInTx(listOld);
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *ByLsm删除
     */
    public  boolean deleteByLsm(JpTabFwqdjy bean) {
        boolean flag = false;

        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(bean.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(bean.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(bean.getQdh()))
                    .buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *ByStrEpc删除
     */
    public  boolean deleteByStrEpc(JpTabFwqd fwqd,JpTabFwqdjy bean) {
        boolean flag = false;
        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.SubEpc.eq(bean.getSubEpc())).list();
            //数据库有相关数据时再清除数据且更新发物清单数据
            if(listBeans.size() > 0 ){
                DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                        .where(JpTabFwqdjyDao.Properties.SubEpc.eq(bean.getSubEpc()))
                        .buildDelete();
                deleteQuery.executeDeleteWithoutDetachingEntities();
                jpTabFwqdService.inUpdate(fwqd);
            }
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     * 获取物资校验信息
     * @param fwqdjy 校验记录
     */
    public  List<JpTabFwqdjy> getfwqdjy(JpTabFwqdjy fwqdjy) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqdjy.getQdh())).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资校验信息
     * @param fwqd
     */
    public  List<JpTabFwqdjy> getfwqdjy(JpTabFwqd fwqd) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao()
                    .queryRawCreate(" WHERE Ysjhbh = '"+fwqd.getYsjhbh()+" ' AND Qdh = '"+fwqd.getQdh()+"'AND Gznd = '"+fwqd.getGznd()+"'AND Lsm = '"+fwqd.getLsm()+"'GROUP BY isOk")
                    .list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取物资校验信息
     */
    public  List<JpTabFwqdjy> getfwqdjy(JpTabFwqd fwqd,String  inLsm,String isOK) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            /*listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao()
                    .queryRawCreate(" WHERE Gznd = '"+fwqd.getGznd()+" ' AND Ysjhbh = '"+fwqd.getYsjhbh()+"'AND IsOk = '"+isOK+"'AND Lsm in ("+inLsm+")")
                    .list();*/
            List<JpTabFwqdjy> listBea = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder().list();

            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqd.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqd.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.IsOk.eq(isOK))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqd.getQdh()))
                    .where(JpTabFwqdjyDao.Properties.Lsm.eq(inLsm)).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取未扫描全的物资校验信息
     * @param fwqdjy 校验记录
     */
    public  List<JpTabFwqdjy> getfwqdjyOkN(JpTabFwqdjy fwqdjy) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Lsm.eq(fwqdjy.getLsm()))
                    .where(JpTabFwqdjyDao.Properties.Jsdwdm.eq(fwqdjy.getJsdwdm()))
                    .where(JpTabFwqdjyDao.Properties.IsOk.eq("N"))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqdjy.getQdh())).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取扫描全的物资校验信息
     * @param fwqdjy 校验记录
     */
    public  List<JpTabFwqdjy> getfwqdjyOkY(JpTabFwqdjy fwqdjy) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.Lsm.eq(fwqdjy.getLsm()))
                    .where(JpTabFwqdjyDao.Properties.Jsdwdm.eq(fwqdjy.getJsdwdm()))
                    .where(JpTabFwqdjyDao.Properties.IsOk.eq("Y"))
                    .where(JpTabFwqdjyDao.Properties.Qdh.eq(fwqdjy.getQdh())).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }

    /**
     * 获取接收单位下未扫描全的物资校验信息
     * @param fwqdjy 校验记录
     */
    public  List<JpTabFwqdjy> getfwqdjyJsdwOkN(JpTabFwqdjy fwqdjy) {

        List<JpTabFwqdjy> listBeans = Lists.newArrayList();
        try{
            listBeans = PrintApplication.getDaoSession().getJpTabFwqdjyDao().queryBuilder()
                    .where(JpTabFwqdjyDao.Properties.Ysjhbh.eq(fwqdjy.getYsjhbh()))
                    .where(JpTabFwqdjyDao.Properties.Jsdwdm.eq(fwqdjy.getJsdwdm()))
                    .where(JpTabFwqdjyDao.Properties.Gznd.eq(fwqdjy.getGznd()))
                    .where(JpTabFwqdjyDao.Properties.IsOk.eq("N")).list();
        } catch(Exception e){
            e.printStackTrace();
        }
        return listBeans;
    }
}
