package com.junmp.print.dao.service;

import android.database.Cursor;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.dao.db.JpTabWzjyDao;
import com.junmp.print.dao.entity.JpTabWzjy;
import com.junmp.print.dao.entity.JpTabWzjyBean;

import org.greenrobot.greendao.query.DeleteQuery;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/23
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class JpTabWzjyService {

    /**
     * 新增记录
     */
    public void insert(JpTabWzjy jpTabWzjy) {

       long listBeans =  PrintApplication.getDaoSession().getJpTabWzjyDao().insert(jpTabWzjy);
    }

    /**
     * 查询所有记录
     */
    public List loadAll() {
        List<JpTabWzjy> listBeans = new ArrayList<>();
            listBeans =  PrintApplication.getDaoSession().getJpTabWzjyDao().loadAll();
        return listBeans;
    }

    /**
     * 查询
     */
    public List loadBy(JpTabWzjy jpTabWzjy) {
        List<JpTabWzjy> listBeans = new ArrayList<>();
            listBeans = PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.Strwzepc.eq(jpTabWzjy.getStrwzepc()))
                    .orderAsc(JpTabWzjyDao.Properties.DtDate)
                    .list();
            /*QueryBuilder<JpTabWzjy> query = PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder().where(

                    new WhereCondition.StringCondition("select * from JP_TAB_WZJY"));
            listBeans = query.listLazy();*/
            /*String where = "WHERE" +" select * from JP_TAB_WZJY";
            listBeans = PrintApplication.getDaoSession().getJpTabWzjyDao().queryRaw(where,new String[]{});*/
        return listBeans;
    }

    /**
     * 按时间段查询物资校验
     */
    public  List<JpTabWzjyBean> getWzJyTj(int startTime,int endTime) {
        List<JpTabWzjyBean> listBeans = new ArrayList<>();//JpTabWzjy jpTabWzjy
        String sql = "select strwzmc ,strwzhx,zxs,y,n from (SELECT strwzmc, strwzhx, dtDate, COUNT(*) AS zxs,\n" +
                "(SELECT COUNT(*) FROM (SELECT t2.strSubEpc FROM JP_TAB_WZJY t2  WHERE t2.strwzdm = t1.strwzdm AND t2.isok = 'Y' GROUP BY t2.strSubEpc  )) as Y,\n" +
                "(SELECT COUNT(*) FROM (SELECT t3.strSubEpc FROM JP_TAB_WZJY t3  WHERE t3.strwzdm = t1.strwzdm AND t3.isok = 'N' GROUP BY t3.strSubEpc  )) as N\n" +
                "FROM (SELECT DISTINCT \n" +
                "      strSubEpc AS wzepc, strwzdm, strwzmc, strwzhx, strXiang, strNum, dtDate, isOk, \n" +
                "      isOut\n" +
                "FROM jp_tab_wzjy)as t1\n" +
                "GROUP BY strwzmc, strwzhx, dtDate)as d where dtDate >= "+ startTime + " and dtDate <="+endTime;
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                cursor.moveToPosition(i);
                JpTabWzjyBean bean = new JpTabWzjyBean();
                bean.setStrwzmc(cursor.getString(0));
                bean.setStrwzhx(cursor.getString(1));
                bean.setZxs(cursor.getInt(2));
                bean.setY(cursor.getInt(3));
                bean.setN(cursor.getInt(4));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     * 查询物资校验
     */
    public  List<JpTabWzjyBean> getWzJyTj() {
        List<JpTabWzjyBean> listBeans = new ArrayList<>();//JpTabWzjy jpTabWzjy
        String sql = "select strwzmc ,strwzhx,zxs,y,n from (SELECT strwzmc, strwzhx, dtDate, COUNT(*) AS zxs,\n" +
                "          (SELECT COUNT(*)\n" +
                "         FROM JP_TAB_WZJY t2\n" +
                "         WHERE t1.strwzdm = t2.strwzdm AND t2.isok = 'Y') AS Y,\n" +
                "          (SELECT COUNT(*)\n" +
                "         FROM JP_TAB_WZJY t3\n" +
                "         WHERE t1.strwzdm = t3.strwzdm AND t3.isok = 'N') AS N\n" +
                "FROM JP_TAB_WZJY t1\n" +
                "GROUP BY strwzmc, strwzhx, dtDate)as d ";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                cursor.moveToPosition(i);
                JpTabWzjyBean bean = new JpTabWzjyBean();
                bean.setStrwzmc(cursor.getString(0));
                bean.setStrwzhx(cursor.getString(1));
                bean.setZxs(cursor.getInt(2));
                bean.setY(cursor.getInt(3));
                bean.setN(cursor.getInt(4));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     *
     */
    public  List<JpTabWzjyBean> getWzJyTjMx(String wzmc, String wzhx) {
        List<JpTabWzjyBean> listBeans = new ArrayList<>();
        String sql = "select wzepc,strXiang ,case isOk when 'Y' then '扫全' else '未扫全' end as state ,strNum from " +
                "(SELECT DISTINCT \n" +
                "      strSubEpc AS wzepc, strwzdm, strwzmc, strwzhx, strXiang, strNum, dtDate, isOk, \n" +
                "      isOut\n" +
                "FROM jp_tab_wzjy) as d" +
                " where (strwzmc = '"+wzmc+"')and (strwzhx = '"+wzhx + "')order by cast(strXiang as integer)";
        Cursor cursor = PrintApplication.getDaoSession().getDatabase().rawQuery (sql,null);
        //判断游标是否为空
        if(cursor.moveToFirst()) {
            //遍历游标
            for(int i=0;i<cursor.getCount();i++){
                cursor.moveToPosition(i);
                JpTabWzjyBean bean = new JpTabWzjyBean();
                bean.setWzepc(cursor.getString(0));
                bean.setStrXiang(cursor.getString(1));
                bean.setState(cursor.getString(2));
                bean.setStrNum(cursor.getString(3));
                listBeans.add(bean);
            }
        }
        return listBeans;
    }

    /**
     *
     */
    public  int getWzJyCount() {

        int count = (int) PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder().count();

        return count;
    }

    /**
     *
     */
    public  Boolean bFoundInWzJy(String epc,String isOK) {
        int count = 0;
        if(isOK.equals("")){
            count = (int) PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.Strwzepc.eq(epc))
                    .count();
        }else{
            count = (int) PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.Strwzepc.eq(epc))
                    .where(JpTabWzjyDao.Properties.IsOk.eq(isOK))
                    .count();
        }
        if(count > 0){
            return true;
        }else{
            return false;
        }
    }

    /**
     * 查询
     * select strwzepc from JP_TAB_WZJY where isOk = #{isOk} and isOut != isOk
     */
    public List<JpTabWzjy> getWzJy(String isOk) {
        List<JpTabWzjy> listBeans = Lists.newArrayList();
        listBeans = PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                .where(JpTabWzjyDao.Properties.IsOk.eq(isOk))
                .where(JpTabWzjyDao.Properties.IsOut.notEq(isOk))
                .list();
        return listBeans;
    }

    /**
     *根据epc删除
     */
    public  boolean delWzJyByEpc(String epc) {
        boolean flag = false;

        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.Strwzepc.eq(epc)).buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *根据是否扫描完全的数据删除
     */
    public  boolean delWzJy(String isOk) {
        boolean flag = false;

        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.IsOk.eq(isOk)).buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    /**
     *根据epc,是否扫描完全的数据删除
     */
    public  boolean delWzJy(String epc,String isOk) {
        boolean flag = false;
        try{
            DeleteQuery deleteQuery= PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                    .where(JpTabWzjyDao.Properties.Strwzepc.eq(epc),JpTabWzjyDao.Properties.IsOk.eq(isOk)).buildDelete();
            deleteQuery.executeDeleteWithoutDetachingEntities();
            flag = true;
        } catch(Exception e){
            e.printStackTrace();
        }
        return flag;
    }

    public void wzjy(JpTabWzjy wzjy) {
        if(!bFoundInWzJy(wzjy.getStrwzepc(),"")){
            wzjy.setIsOut("N");
            long id =  PrintApplication.getDaoSession().getJpTabWzjyDao().insert(wzjy);
        }else{
            if(bFoundInWzJy(wzjy.getStrwzepc(),"N")){
                List<JpTabWzjy> listBeans = Lists.newArrayList();
                listBeans = PrintApplication.getDaoSession().getJpTabWzjyDao().queryBuilder()
                        .where(JpTabWzjyDao.Properties.Strwzepc.eq(wzjy.getStrwzepc()))
                        .list();
                List<JpTabWzjy> listBeansReal = new ArrayList<>();
                for(JpTabWzjy beanReal : listBeans){
                    beanReal.setIsOk(wzjy.getIsOk());
                    listBeansReal.add(beanReal);
                }
                PrintApplication.getDaoSession().getJpTabWzjyDao()
                        .updateInTx(listBeansReal);
            }
        }
    }
}
