package com.junmp.print.presenter;

import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.util.Xml;
import android.widget.EditText;

import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.dao.service.JpTabFwqdjyService;
import com.junmp.print.iview.IDataOutView;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.VersionUtils;
import com.junmp.print.util.XMLUtil;

import org.xmlpull.v1.XmlSerializer;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/18
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataOutPresenter extends BaseFragmentPresenter<IDataOutView> {

    public DataOutPresenter(BaseFragment context) {
        super(context);
    }

    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();
    JpTabFwqdjyService jpTabFwqdjyService = new JpTabFwqdjyService();

    /**
     * 获取工作年度
     */
    public void getGznd() {
        List<String> listGznd = new ArrayList<>();
        Calendar calendar = Calendar.getInstance();
        //获取系统的日期
        //年
        int yearNow = calendar.get(Calendar.YEAR);
        //无工作年份则显示当前年份
        try{
            listGznd =  jpTabFwqdService.getGznd();
            if(listGznd.size()>0){

            }else{
                listGznd.add(String.valueOf(yearNow));
            }
        }catch (Exception e ){
            listGznd.add(String.valueOf(yearNow));
        }finally {
            getView().showGznd(listGznd);
        }


    }
    /**
     * 获取运输计划单号
     */
    public void getCbox_ysjhdhValue(String gznd) {

        List<String> listYsjhdh = new ArrayList<>();
        try{
            listYsjhdh =  jpTabFwqdService.getYsjhbh(gznd);
            if(listYsjhdh.size()>0){
                getView().showYsjhdh(listYsjhdh);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.ysjh_no_data));
                //运输计划单号为空时，清单号数据也为空
                getView().showQdh(null);
            }
        }catch (Exception e ){
          mContext.showMessage("Err:"+e.getMessage());
        }

    }
    /**
     * 获取发物清单号
     */
    public void getCbox_qdhValue( String strYsjhdh) {

        List<JpTabFwqd> listYsjhdh = new ArrayList<>();
        try{
            listYsjhdh =  jpTabFwqdService.getQdh(strYsjhdh);
            if(listYsjhdh.size()>0){
                getView().showQdh(listYsjhdh);
            }else{
                //运输计划单号为空时，清单号数据也为空
                getView().showQdh(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    /**
     * 数据导出
     */
    public void outputWzjy(String uploadname,String gznd,String ysjhdh, String qdh,String swdwmc, String ver) {
        try{
            JpTabFwqd fwqd = new JpTabFwqd();
            fwqd.setGznd(gznd);
            fwqd.setYsjhbh(ysjhdh);
            fwqd.setQdh(qdh);
            fwqd.setIsOut("Y");


            JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
            fwqdjy.setGznd(gznd);
            fwqdjy.setYsjhbh(ysjhdh);
            fwqdjy.setQdh(qdh);
            fwqdjy.setIsOut("Y");
            List<JpTabFwqdjy> listjy = jpTabFwqdjyService.getfwqdjy(fwqdjy);

            if(listjy.size()>0){

                String strSwdwmc = ysjhdh + "_" + qdh +"_"+swdwmc;
                //导出xml
                String fileName =  XMLUtil.createXml(listjy,uploadname,strSwdwmc, ver);
                //String fileName = Environment.getExternalStorageDirectory()+"/store/"+uploadname + "/" + strSwdwmc + "_" + TimeUtil.getDateLongNo()+".xml";
                if(fileName != null){
                    jpTabFwqdjyService.updateIsOut(fwqdjy);
                    jpTabFwqdService.outUpdate(fwqd);
                    mContext.showMessage(String.valueOf(listjy.size()) + "条数据已导出到" + fileName);
                    scanFile(fileName);
                }else{
                    mContext.showMessage(UIUtil.getString(R.string.export_fail));
                }
            }else{
                mContext.showMessage(UIUtil.getString(R.string.fail_data_out_null));
            }
        }catch (Exception e ){
            mContext.showMessage(UIUtil.getString(R.string.export_fail)+":"+e.getMessage());
        }

    }

    /**
     * 清空当前清单号的校验数据
     */
    public void clearQdhJydata(JpTabFwqd fwqd, JpTabFwqdjy fwqdjy) {

        try{
            jpTabFwqdService.clearUpdate(fwqd);
            jpTabFwqdjyService.deleteByLsm(fwqdjy);

            mContext.showMessage("发物清单["+fwqd.getQdh()+"]的校验数据已清空！");
        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }

    /**触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
     * @param fileName
     * */
    public void scanFile(String fileName){
        //触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
        MediaScannerConnection.scanFile(mContext.getActivity(), new String[]{fileName}, new String[]{"application/octet-stream"}, new MediaScannerConnection.OnScanCompletedListener() {
            @Override
            public void onScanCompleted(final String path, final Uri uri) {
                //your file has been scanned!
            }
        });
    }
}
