package com.junmp.print.presenter;

import android.util.Log;

import com.google.common.collect.Lists;
import com.junmp.print.PrintApplication;
import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.dao.service.JpTabFwqdjyService;
import com.junmp.print.iview.IOutCheckView;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.UIUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * <pre>
 * 描述：物资出厂校验
 * 版本：1.0
 * 日期：2018/5/18
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class OutCheckPresenter extends BaseActivityPresenter<IOutCheckView> {

    public OutCheckPresenter(BaseActivity context) {
        super(context);
    }

    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();
    JpTabFwqdjyService jpTabFwqdJyService = new JpTabFwqdjyService();

    /**
     * 获取运输计划
     * */
    public void getYsjhbhIsY() {
        List<String> listYsjhdh = new ArrayList<>();
        try{
            listYsjhdh =  jpTabFwqdService.getYsjhbhIsY();
            if(listYsjhdh.size()>0){
                getView().showYsjhdh(listYsjhdh);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.ysjh_no_data));
                //运输计划单号为空时，清单号数据也为空
                getView().showQdh(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }

    /**
     * 获取发物清单号
     */
    public void getCbox_qdhValue( String strYsjhdh) {

        List<JpTabFwqd> listYsjhdh = new ArrayList<>();
        try{
            listYsjhdh =  jpTabFwqdService.getQdh(strYsjhdh);
            if(listYsjhdh.size()>0){
                getView().showQdh(listYsjhdh);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.fwqd_no_data));
                //运输计划单号为空时，清单号数据也为空
                getView().showQdh(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    /**
     * 获取物资名称
     */
    public void getCbox_wzmcValue(JpTabFwqd bean) {
        List<JpTabFwqd> listWzmc = new ArrayList<>();
        try{
            listWzmc =  jpTabFwqdService.getWzmc(bean,true);
            if(listWzmc.size()>0){
                getView().showWzmc(listWzmc);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.wzmc_no_data));
                //物资名称为空时，物资号型也为空
                getView().showWzhx(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    /**
     * 获取物资号型
     */
    public void getCbox_wzhxValue(JpTabFwqd fwqd) {
        List<JpTabFwqd> listWzhx = new ArrayList<>();
        try{
            listWzhx =  jpTabFwqdService.getWzhx(fwqd);
            if(listWzhx.size()>0){
                getView().showWzhx(listWzhx);
            }else{
                mContext.showMessage(UIUtil.getString(R.string.wzhx_no_data));
                //物资名称为空时，物资号型也为空
                getView().showWzhx(null);
            }
        }catch (Exception e ){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    public void getFwqdDictionary(JpTabFwqd fwqd) {
        List<JpTabFwqd> listBeans = Lists.newArrayList();
        //mContext.showWaitingDialog("正在加载数据");
        try{
            PrintApplication.getDaoSession().getJpTabFwqdDao().detachAll();//清理缓存
        //根据check不同选择不同的查询语句
        if(getView().wzname_ck().isChecked() || getView().wzhx_ck().isChecked()){
            if(getView().wzhx_ck().isChecked() ){
                //按物资号型扫描
                listBeans = jpTabFwqdService.getWzhxOne(fwqd);
                // listBeans = jpTabFwqdService.getWzhx(fwqd);   按物资扫描
            }else{
                //按清单扫描
                listBeans = jpTabFwqdService.getWzmc(fwqd,false);
            }

        }else{
            //按物资号型扫描
            //listBeans = jpTabFwqdService.getWzhxOne(fwqd);
        }
            getView().getFwqdDictonary(listBeans);
            //mContext.hideWaitingDialog();
        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
            //mContext.hideWaitingDialog();
        }

    }

    /**
     * 获取扫描的物资校验数据
     */
    public void getFwqdjyInfo(List<JpTabFwqdjy> fwqdjyList, JpTabFwqd fwqd, String tmpLsm, String isOk) {
        try{
            getView().getFwqdjyList().clear();
            PrintApplication.getDaoSession().getJpTabFwqdjyDao().detachAll();//清理缓存
            fwqdjyList = jpTabFwqdJyService.getfwqdjy(fwqd,tmpLsm,isOk);
            if(fwqdjyList.size()>0){
                getView().getFwqdjyList().addAll(fwqdjyList);
                getFwqdjyData(fwqdjyList,isOk);
            }
        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
        }

    }

    /**
     * 获取未扫全的物资
     */
    public void getFwqdjyData(List<JpTabFwqdjy> fwqdjyList, String isOk) {

        try{
            if(fwqdjyList.size()>0){
                List<ProductEpc> listFromData = new ArrayList<>();
                for(int j=0;j< fwqdjyList.size();j++ ){
                    JpTabFwqdjy fwqdjy = fwqdjyList.get(j);
                    List<String> epcs = getWzjyEpcs(fwqdjy);
                    /*for(String epc : epcs){
                        ProductEpc pro = new ProductEpc();
                        pro.setStrEpc(epc);
                        pro.getInfoFormEpc();
                        getView().LoadProductTolist(pro,isOk);
                    }*/
                    for(int i=0;i< epcs.size();i++){
                        ProductEpc pro = new ProductEpc();
                        pro.setStrEpc(epcs.get(i));
                        pro.getInfoFormEpc();

                        if(isOk.equals("N")){
                            listFromData.add(pro);
                        }
                        //getView().LoadProductTolist(pro,isOk);
                    }
                }
                getView().getListFromData(listFromData,isOk);
            }

        }catch (Exception e){
            mContext.showMessage("Err:"+e.getMessage());
        }
    }

    private List<String> getWzjyEpcs(JpTabFwqdjy fwqdjy) {
        List<String> epcs = new ArrayList<>();
        if(fwqdjy.getStrepc().length() > 10){
            epcs.add(fwqdjy.getStrepc());
        }
        if(fwqdjy.getStrepc1().length() > 10){
            epcs.add(fwqdjy.getStrepc1());
        }
        if(fwqdjy.getStrepc2().length() > 10){
            epcs.add(fwqdjy.getStrepc2());
        }
        if(fwqdjy.getStrepc3().length() > 10){
            epcs.add(fwqdjy.getStrepc3());
        }
        return epcs;
    }

}
