package com.junmp.print.ui.data.importmat;

import android.content.res.Resources;
import android.content.res.XmlResourceParser;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.util.Xml;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.TabBzglWzdm;
import com.junmp.print.iview.IImportMatView;
import com.junmp.print.presenter.ImportMatPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.VersionUtils;
import com.junmp.print.view.HorizontalProgressBar;
import com.junmp.print.view.progress.NumberProgressBar;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：物资代码导入
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class ImportMatFragment extends BaseFragment<IImportMatView, ImportMatPresenter> implements IImportMatView {

    @BindView(R.id.bt_data_wzdm_import)
    TextView bt_import;

    @BindView(R.id.numberbar)
    NumberProgressBar bnp;

    @Override
    protected int setView() {
        return R.layout.fragment_data_importmat;
    }

    @Override
    public void onStop() {
        super.onStop();
    }
    @Override
    protected void init(View view) {
        bnp.setOnProgressBarListener(this::onProgressChange);
        bnp.setReachedBarHeight(10);
        bnp.setUnreachedBarHeight(10);
        bnp.setProgressTextSize(15);
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    protected ImportMatPresenter createPresenter() {
         return new ImportMatPresenter(this);
    }

    private Thread thread;//读取文件线程
    @OnClick({R.id.bt_data_wzdm_import})
    public void onViewClick(View view){
        switch (view.getId()) {
//             “物资代码导入”
            case R.id.bt_data_wzdm_import:
                //启动一个线程读取文件内容
                importWzdm();
                break;
        }
    }

    Thread myThread = new Thread(new Runnable() {
        @Override
        public void run() {
            parse();
            //做完以后
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    //回主线程
                    bt_import.setBackgroundColor(UIUtil.getColor(R.color.green_bt));
                    bt_import.setEnabled(true);
                }
            });
        }
    });

    private void importWzdm() {
        bnp.setProgress(0);
        bt_import.setBackgroundColor(UIUtil.getColor(R.color.green_bt_unEnable));
        bt_import.setEnabled(false);
        myThread.start();
    }

    private void parse() {
        Message msg = new Message();
        File file = new File(Environment.getExternalStorageDirectory() + "/JPQYHand/Update/TAB_BZGL_WZDM.xml");
        try {
            FileInputStream fis = new FileInputStream(file);
            //获取Xml的pull解析器
            XmlPullParser xp = Xml.newPullParser();

            //指定使用什么编码去解析xml文件
            xp.setInput(fis,"gb2312");

            //开始解析
            //需要判断当前解析到什么标签，因为解析到不同的标签需要做不同的操作
            //通过获取当前标签的事件类型
            int type = xp.getEventType();
            TabBzglWzdm tabBzglWzdm = null;
            List<TabBzglWzdm>  mList = new ArrayList<>();
            int num = 0;
            int all = 0;
            while (type!=XmlPullParser.END_DOCUMENT){
                switch (type) {
                    case XmlPullParser.START_TAG:
                        if ("results".equals(xp.getName())) {//获取当前标签的名字
                        all = Integer.valueOf(xp.nextText());
                        int finalAll = all;
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                bnp.setMax(finalAll);
                            }
                        });
                        } else if ("TAB__BZGL__WZDM__dc".equals(xp.getName())) {//获取当前标签的名字
                            tabBzglWzdm = new TabBzglWzdm();
                            num = num + 1;
                        } else if ("wzdm".equals(xp.getName())) {
                            String wzdm = xp.nextText();//获取当前节点的下一个节点的文本，并把指针移动至当前节点的结束节点
                            tabBzglWzdm.setWZDM(wzdm);
                        } else if ("hxdm".equals(xp.getName())) {
                            String hxdm = xp.nextText();//获取当前节点的下一个节点的文本，并把指针移动至当前节点的结束节点
                            tabBzglWzdm.setHXDM(hxdm);
                        } else if ("zbqmc".equals(xp.getName())) {
                            String zbqmc = xp.nextText();
                            tabBzglWzdm.setZBQMC(zbqmc);
                        } else if ("hx".equals(xp.getName())) {
                            String hx = xp.nextText();
                            tabBzglWzdm.setHX(hx);
                        } else if ("lsm".equals(xp.getName())) {
                            String lsm = xp.nextText();
                            tabBzglWzdm.setLSM(lsm);
                        }
                        break;
                    case XmlPullParser.END_TAG:
                        if ("TAB__BZGL__WZDM__dc".equals(xp.getName())) {
                            mList.add(tabBzglWzdm);
                            mPresenter.insertWzdm(tabBzglWzdm);
                            LogUtils.e("新增记录num---"+num+"all---"+all+"总量--"+bnp.getMax());
                            Message msgUp = new Message();
                            msgUp.what = 1;
                            mHandleCount.sendMessage(msgUp);
                        }
                        break;
                   }
                    //指针移动至下一个节点，并且获取它的事件类型
                    type = xp.next();
                }

                if( mList.size() == 0){
                    msg.what = 4;
                    mHandleCount.sendMessage(msg);
                }
            } catch (XmlPullParserException e1) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage("Err:"+ e1.getMessage());
        } catch (FileNotFoundException e1) {
            msg.what = 3;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage(UIUtil.getString(R.string.fail_null));
        } catch (IOException e1) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage("Err:"+ e1.getMessage());
        }catch (Exception e) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e.getStackTrace();
            //showMessage("Err:"+ e.getMessage());
        }finally {
        }
    }

    @Override
    public void onProgressChange(int current, int max) {
        if(current == max) {
            showMessage("导入成功");
        }
    }

    private Handler mHandleCount = new Handler(){
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what){
                case 1://更新进度条
                    bnp.incrementProgressBy(1);
                    break;
                case 2://解析XML错误
                    showMessage("解析XML错误");
                    break;
                case 3://
                    showMessage(UIUtil.getString(R.string.fail_null));
                    break;
                case 4://
                    showMessage(UIUtil.getString(R.string.fail_data_null));
                    break;
            }
        }
    };

}

