package com.junmp.print.ui.data.randomcheck;

import android.os.Bundle;
import android.widget.AbsListView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.SimpleAdapter;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.plan.maintain.date.TfMaintainDateActivity;
import com.junmp.print.util.LogUtils;
import com.junmp.print.view.MyListView;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import butterknife.BindView;


/**
 * <pre>
 * 描述：随机校验详情
 * 版本：1.0
 * 日期：2018/5/28
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RandomCheckCxjgMxActivity extends BaseActivity{

    @BindView(R.id.wzName_tv)
    TextView wzName_tv;

    @BindView(R.id.wzHxName_tv)
    TextView wzHxName_tv;

    @BindView(R.id.data_random_cxjgmx_item_lv)
    MyListView lvMatrlItem;

    @BindView(R.id.scrollView)
    ScrollView scrollView;

    private int startIndex;
    private int endIndex;
    private final int pageSize = 15;

    List<Map<String, ?>> list = new ArrayList<Map<String, ?>>();
    List<Map<String, ?>> listFor = new ArrayList<Map<String, ?>>();
    SimpleAdapter adapter;
    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_data_randomcheck_cxjgmx;
    }

    public void initView() {
        Bundle bundle = getIntent().getExtras();
        String wzmc = bundle.getString("wzmc");
        String wzhx = bundle.getString("wzhx");
        wzName_tv.setText(wzmc);
        wzHxName_tv.setText(wzhx);
        List<JpTabWzjyBean> listBeans = (List<JpTabWzjyBean>) bundle.getSerializable("getWzJyTjMxList");
        showList(listBeans);
    }

    private void showList(List<JpTabWzjyBean> listBeans) {
        String[] Coname = new String[]{"物资EPC","箱号","状态","数量"};
        Map<String, String> h = new HashMap<String, String>();
        if(listBeans.size()>0){
            for(int i=0;i<listBeans.size();i++){
                Map<String, String> m = new HashMap<String, String>();
                m.put(Coname[0], listBeans.get(i).getWzepc());
                m.put(Coname[1], listBeans.get(i).getStrXiang());
                m.put(Coname[2], listBeans.get(i).getState());
                m.put(Coname[3], listBeans.get(i).getStrNum());
                list.add(m);
            }
            listFor.addAll(getDataService(0,pageSize));
            adapter = new SimpleAdapter(this,listFor, R.layout.activity_data_randomcheck_cxjgmx_item,
                    Coname,
                    new int []{R.id.wzepc_tv,R.id.wzXiang_tv,R.id.wzState_tv,R.id.wzNum_tv});
            lvMatrlItem.setAdapter(adapter);
            lvMatrlItem.setScrollView(scrollView);

            lvMatrlItem.setOnScrollListener(new ScrollListener());
            startIndex = 0;
            endIndex = pageSize;
            //setListViewHeightBasedOnChildren(lvMatrlItem);
        }
    }

    public final class ScrollListener implements AbsListView.OnScrollListener {
        boolean isLastRow = false;
        @Override
        public void onScrollStateChanged(AbsListView view, int scrollState) {
            LogUtils.e("---->" + scrollState);
            switch (scrollState) {
                case SCROLL_STATE_IDLE://滚到底部
                    if(isLastRow){
                        showMessage("");
                        if(view.getCount() < list.size()){//没有加载全部数据的时候
                            startIndex += pageSize;
                            endIndex += pageSize;
                            listFor.addAll( getDataService(startIndex, endIndex));
                            adapter.notifyDataSetChanged();

                        }else{
                            showMessage("数据已经加载完全！");
                        }
                        isLastRow = false;
                    }
                    break;
                case SCROLL_STATE_TOUCH_SCROLL:
                    break;
                case SCROLL_STATE_FLING:
                    break;
            }
            //当滚动到最后一行且停止滚动时，执行加载

        }

        @Override
        public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
            if(firstVisibleItem + visibleItemCount == totalItemCount && totalItemCount > 0 ) {
                isLastRow = true;
            }
        }

    }

    /**
     * 加载显示数据
     * @param from
     * @param to
     * @return
     */
    public  List<Map<String, ?>> getDataService(int from, int to) {
        List<Map<String, ?>> productfor = new ArrayList<>();
        if(to>list.size()){
            to = list.size();
            endIndex = to;
            startIndex = to -pageSize;
        }
        for (int i = from; i < to; i++) {
            productfor.add(list.get(i));
        }
        LogUtils.d("加载数据：" + Integer.toString(productfor.size()));
        return productfor;
    }

}
