package com.junmp.print.ui.fragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.data.importmat.ImportMatFragment;
import com.junmp.print.ui.data.randomcheck.RandomCheckFragment;
import com.junmp.print.ui.matcheck.data.DataActivity;
import com.junmp.print.ui.matcheck.data.out.DataOutFragment;
import com.junmp.print.ui.matcheck.data.random.DataRandomFragment;
import com.junmp.print.ui.matcheck.plan.maintain.MaintainFragmentPagerAdapter;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/4/24
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataFragment extends BaseFragment {

    @BindView(R.id.tv_item_import)
    TextView importTv;

    @BindView(R.id.tv_item_randomSe)
    TextView randomTv;

    @BindView(R.id.tv_item_import_color)
    View importView;

    @BindView(R.id.tv_item_randomSe_color)
    View randomView;

    @BindView(R.id.dataViewpager)
    ViewPager myViewPager;

    private List<Fragment> list;
    private MaintainFragmentPagerAdapter adapter;

    @Override
    protected int setView() {
        return R.layout.fragment_data;
    }

    @Override
    protected void init(View view) {
        // 设置菜单栏的点击事件
        myViewPager.setOnPageChangeListener(new MyPagerChangeListener());

        //把Fragment添加到List集合里面
        list = new ArrayList<>();
        list.add(new ImportMatFragment());
        list.add(new RandomCheckFragment());
        adapter = new MaintainFragmentPagerAdapter(getChildFragmentManager(), list);
        myViewPager.setAdapter(adapter);
        myViewPager.setCurrentItem(0);  //初始化显示第一个页面
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @OnClick({R.id.tv_item_import,R.id.tv_item_randomSe})
    public void onViewClick(View view){
        switch (view.getId()) {
//             “物资代码导入”
            case R.id.tv_item_import:
                myViewPager.setCurrentItem(0);
                break;
//             “随机校验查询”
            case R.id.tv_item_randomSe:
                myViewPager.setCurrentItem(1);
                break;
        }
    }

    /**
     * 设置一个ViewPager的侦听事件，当左右滑动ViewPager时菜单栏被选中状态跟着改变
     *
     */
    public class MyPagerChangeListener implements ViewPager.OnPageChangeListener {

        @Override
        public void onPageScrollStateChanged(int arg0) {
        }

        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {
        }

        @Override
        public void onPageSelected(int arg0) {
            switch (arg0) {
                case 0:
                    importTv.setTextColor(getResources().getColor(R.color.green));
                    importView.setBackgroundResource(R.color.green);
                    randomTv.setTextColor(getResources().getColor(R.color.text_color));
                    randomView.setBackgroundResource(R.color.float_transparent);
                    break;
                case 1:
                    importTv.setTextColor(getResources().getColor(R.color.text_color));
                    importView.setBackgroundResource(R.color.float_transparent);
                    randomTv.setTextColor(getResources().getColor(R.color.green));
                    randomView.setBackgroundResource(R.color.green);
                    break;
            }
        }
    }
}

