package com.junmp.print.ui.login;

import android.text.TextUtils;

import com.junmp.print.MainActivity;
import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.dao.service.JpTabConfigService;
import com.junmp.print.presenter.BaseActivityPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.util.UIUtil;


/**
 * <pre>
 * 描述：登录数据处理
 * 版本：1.0
 * 日期：2017/8/24
 * 作者：ningzp@junmp.com.cn
 * </pre>
 */

public class LoginPresenter extends BaseActivityPresenter<ILoginView> {

    public LoginPresenter(BaseActivity context) {
        super(context);
    }

    JpTabConfigService jpTabConfigService = new JpTabConfigService();


    /**
     * 用户登录
     */
    public void login() {
        String username = getView().getEtUserName().getText().toString().trim();
        String password = getView().getEtPwd().getText().toString().trim();

        if (TextUtils.isEmpty(username)) {
            UIUtil.showToast(UIUtil.getString(R.string.username_not_empty));
            return;
        }

        if (TextUtils.isEmpty(password)) {
            UIUtil.showToast(UIUtil.getString(R.string.password_not_empty));
            return;
        }

        try{
            JpTabConfig jpTabConfig = new JpTabConfig();
            jpTabConfig = (JpTabConfig) jpTabConfigService.getConfig().get(0);
            if(jpTabConfig.getStruser().equals(username)  && jpTabConfig.getStrpass().equals(password) ){
                UserCache.save(jpTabConfig);
                mContext.jumpToActivity(MainActivity.class);
            }else{
                UIUtil.showToast(UIUtil.getString(R.string.login_error));
            }
        }catch (Exception e){
            UIUtil.showToast("Err:"+e.getMessage());
        }

    }


}
