package com.junmp.print.ui.matcheck.data.out;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;
import com.junmp.print.iview.IDataOutView;
import com.junmp.print.presenter.DataOutPresenter;
import com.junmp.print.presenter.DataRandomPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.plan.maintain.date.TfMaintainDateActivity;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.VersionUtils;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;


/**
 * <pre>
 * 描述：出厂校验数据上报
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataOutFragment extends BaseFragment<IDataOutView, DataOutPresenter> implements IDataOutView {

    //工作年度
    @BindView(R.id.dataOut_gznd_sp)
    Spinner gznd_sp;

    //运输计划单
    @BindView(R.id.dataOut_transferPlan_sp)
    Spinner transferPlan_sp;

    //发物清单
    @BindView(R.id.dataOut_qdh_sp)
    Spinner qdh_sp;

    //收物单位
    @BindView(R.id.dataOut_unit_et)
    TextView unit_et;

    private List<JpTabFwqd> listQdh;
    private List<String> listStrQdh = new ArrayList<>();
    private List<String> listStrYsjh = new ArrayList<>();
    private List<String> listStrGznd = new ArrayList<>();
    private int qdhSelect = 0;
    private ArrayAdapter<String> gznd_arr_adapter,transferPlan_adapter,qdh_adapter;

    @Override
    protected int setView() {
        return R.layout.fragment_check_data_out;
    }

    @Override
    protected void init(View view) {

        mPresenter.getGznd();
        //gznd_sp.setOnItemSelectedListener(spnGzndItemSelLis);
        transferPlan_sp.setOnItemSelectedListener(spnysjhdhItemSelLis);
        qdh_sp.setOnItemSelectedListener(spnQdhItemSelLis);
    }

    @Override
    protected void intView(View view) {

    }

    @Override
    protected DataOutPresenter createPresenter() {
        return new DataOutPresenter(this);
    }

    @OnClick({R.id.dataOut_export_tv,R.id.dataOut_clean_tv,R.id.dataOut_exportAll_tv,R.id.dataOut_cleanFile_tv})
    public void onViewClick(View view){
        switch (view.getId()) {
            //校验数据导出
            case R.id.dataOut_export_tv:
                dataExport();
                break;
            //校验数据清空
            case R.id.dataOut_clean_tv:
                clean();
                break;
            //全部导出
            case R.id.dataOut_exportAll_tv:

                break;
            //导出文件清空
            case R.id.dataOut_cleanFile_tv:
                clearExport();
                break;
        }
    }

    /**
     * 清空发物清单校验XML文件
     * */
    private void clearExport() {

        showMessage("");
        // 这里的属性可以一直设置，因为每次设置后返回的是一个builder对象
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        // 设置提示框的标题
        builder.setTitle(UIUtil.getString(R.string.clean_all_checkFail)).
                // 设置提示框的图标
                        setIcon(R.mipmap.ic_launcher).
                // 设置要显示的信息
                        setMessage(UIUtil.getString(R.string.clean_all_checkFail_sure)).
                // 设置确定按钮
                        setPositiveButton(UIUtil.getString(R.string.dialog_ok), new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        DataRandomPresenter presenter = new DataRandomPresenter(DataOutFragment.this);
                        presenter.clean("FwqdjyXml");
                    }
                }).

                // 设置取消按钮,null是什么都不做，并关闭对话框
                        setNegativeButton(UIUtil.getString(R.string.dialog_cancel), null);

        // 生产对话框
        AlertDialog alertDialog = builder.create();
        // 显示对话框
        alertDialog.show();
    }

    private void dataExport() {

        showMessage("");
        if(listStrQdh == null || listStrQdh.size() == 0){
           showMessage(UIUtil.getString(R.string.qdy_not_empty));
        }else{
            try{
                showMessage("");
                String gznd = gznd_sp.getSelectedItem().toString();
                String ysjhdh = transferPlan_sp.getSelectedItem().toString();
                String qdh = qdh_sp.getSelectedItem().toString();
                String swdwmc = unit_et.getText().toString().trim();
                //创建校验信息XML文件
                mPresenter.outputWzjy("FwqdjyXml",gznd,ysjhdh,qdh,swdwmc, VersionUtils.getVersionName(getActivity()));
            }catch (Exception e){
                showMessage("Err:"+e.getMessage());
            }
        }
    }

    /**
     * 清空当前清单号的校验数据
     */
    private void clean() {

            showMessage("");
            // 这里的属性可以一直设置，因为每次设置后返回的是一个builder对象
            AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
            // 设置提示框的标题
            builder.setTitle(UIUtil.getString(R.string.title_clean)).
                    // 设置提示框的图标
                            setIcon(R.mipmap.ic_launcher).
                    // 设置要显示的信息
                            setMessage(UIUtil.getString(R.string.clean_qdhjy)).
                    // 设置确定按钮
                            setPositiveButton(UIUtil.getString(R.string.dialog_ok), new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            clearQdhJydata();

                        }
                    }).

                    // 设置取消按钮,null是什么都不做，并关闭对话框
                            setNegativeButton(UIUtil.getString(R.string.dialog_cancel), null);

            // 生产对话框
            AlertDialog alertDialog = builder.create();
            // 显示对话框
            alertDialog.show();

    }



    private void clearQdhJydata() {

        showMessage("");

        if(listStrQdh == null || listStrQdh.size() == 0){
            showMessage(UIUtil.getString(R.string.qdy_not_empty));
            return;
        }
        try{
            String gznd = gznd_sp.getSelectedItem().toString();
            String ysjhdh = transferPlan_sp.getSelectedItem().toString();
            String qdh = qdh_sp.getSelectedItem().toString();

            JpTabFwqd fwqd = new JpTabFwqd();
            fwqd.setGznd(gznd);
            fwqd.setYsjhbh(ysjhdh);
            fwqd.setQdh(qdh);
            fwqd.setIsOK("N");
            fwqd.setIsOut("N");
            fwqd.setJydate(TimeUtil.getDate());
            fwqd.setJynum("0");

            JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
            fwqdjy.setGznd(gznd);
            fwqdjy.setYsjhbh(ysjhdh);
            fwqdjy.setQdh(qdh);
            fwqdjy.setIsOut("N");

            mPresenter.clearQdhJydata(fwqd,fwqdjy);

        }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }


    }

    /**
   * 展示工作年度
    */
   @Override
    public void showGznd(List<String> listGznd) {
       if(listGznd != null){
           this.listStrGznd = listGznd;
           gznd_sp.setOnItemSelectedListener(spnGzndItemSelLis);
           //适配器
           gznd_arr_adapter= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, listGznd);
           //设置样式
           gznd_arr_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
           //加载适配器
           gznd_sp.setAdapter(gznd_arr_adapter);

           gznd_sp.setSelection(0,true);
       }
    }

    @Override
    public void showYsjhdh(List<String> list) {
        if(list != null){
            this.listStrYsjh = list;
            //适配器
            transferPlan_adapter= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, list);
            //设置样式
            transferPlan_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            transferPlan_sp.setAdapter(transferPlan_adapter);
        }
    }

    @Override
    public void showQdh( List<JpTabFwqd> list) {
       if(list != null){
           this.listQdh = list;
           List<String> listQdhRe= new ArrayList<>();
           for(JpTabFwqd bean : list){
               listQdhRe.add(bean.getQdh());
           }

           this.listStrQdh = listQdhRe;
           //适配器
           qdh_adapter= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, listQdhRe);
           //设置样式
           qdh_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
           //加载适配器
           qdh_sp.setAdapter(qdh_adapter);
       }
    }

    private Spinner.OnItemSelectedListener spnGzndItemSelLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            String gznd = parent.getSelectedItem().toString();
            mPresenter.getCbox_ysjhdhValue(gznd);

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };

    private Spinner.OnItemSelectedListener spnysjhdhItemSelLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            String strYsjhdh = parent.getSelectedItem().toString();
            mPresenter.getCbox_qdhValue(strYsjhdh);

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };

    private Spinner.OnItemSelectedListener spnQdhItemSelLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            //填写指定收物单位
            qdhSelect = position;
            unit_et.setText(listQdh.get(position).getSwdwmc());

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
}

