package com.junmp.print.ui.matcheck.data.random;

import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.iview.IDataRandomView;
import com.junmp.print.presenter.DataRandomPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：随机校验数据上报
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class DataRandomFragment extends BaseFragment<IDataRandomView, DataRandomPresenter> implements IDataRandomView {

    @BindView(R.id.checkDate_out_tv)
    TextView checkDate_out_tv;

    @BindView(R.id.checkDate_clean_tv)
    TextView checkDate_clean_tv;

    @Override
    protected int setView() {
        return R.layout.fragment_check_data_random;
    }

    @Override
    protected void init(View view) {

    }

    @Override
    protected void intView(View view) {

    }

    @Override
    protected DataRandomPresenter createPresenter() {
        return new DataRandomPresenter(this);
    }

    @OnClick({R.id.checkDate_out_tv,R.id.checkDate_clean_tv})
    public void onViewClick(View view){
        switch (view.getId()) {
            //随机校验数据导出
            case R.id.checkDate_out_tv:
                out();
                break;
            //随机校验数据清空
            case R.id.checkDate_clean_tv:
                clean();
                break;
        }
    }

    /**
     * 随机校验数据导出
     * */
    private void out() {
        try{
            showMessage("");
            mPresenter.dateOut();
        }catch (Exception e){
            showMessage("Err:"+e.getMessage());
        }

    }

    /**
     * 随机校验数据清空
     * */
    private void clean() {

        // 这里的属性可以一直设置，因为每次设置后返回的是一个builder对象
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        // 设置提示框的标题
        builder.setTitle(UIUtil.getString(R.string.clean_all_checkFail)).
                // 设置提示框的图标
                        setIcon(R.mipmap.ic_launcher).
                // 设置要显示的信息
                        setMessage(UIUtil.getString(R.string.clean_all_checkFail_sure)).
                // 设置确定按钮
                        setPositiveButton(UIUtil.getString(R.string.dialog_ok), new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        showMessage("");
                       mPresenter.clean("TagsXml");
                    }
                }).

                // 设置取消按钮,null是什么都不做，并关闭对话框
                        setNegativeButton(UIUtil.getString(R.string.dialog_cancel), null);

        // 生产对话框
        AlertDialog alertDialog = builder.create();
        // 显示对话框
        alertDialog.show();
    }

}
