package com.junmp.print.ui.matcheck.out.outcheck;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.util.TimeUtils;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.SimpleAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.junmp.print.MainActivity;
import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdjy;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.Product_fwqd;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.dao.service.JpTabFwqdjyService;
import com.junmp.print.iview.IOutCheckView;
import com.junmp.print.presenter.OutCheckPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.matcheck.out.outcount.OutCountAdapter;
import com.junmp.print.util.LogUtil;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.Util;
import com.junmp.print.view.CustomTitleBar;
import com.junmp.print.view.MyListView;
import com.junmp.print.view.MyScrollView;
import com.uhf.scanlable.UHfData;

import java.io.IOException;
import java.lang.ref.WeakReference;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.TimeUnit;

import butterknife.BindView;
import butterknife.OnClick;
import io.reactivex.Observable;
import io.reactivex.Scheduler;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;
import io.reactivex.internal.disposables.ListCompositeDisposable;
import io.reactivex.schedulers.Schedulers;

import static com.junmp.print.util.XMLUtil.createXml;

/**
 * <pre>
 * 描述：物资出厂校验
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * 编辑：物资默认按清单扫描，剔除按物资扫描，改为按物资号型扫描  20190121
 * </pre>
 */

public class OutCheckActivity extends BaseActivity<IOutCheckView, OutCheckPresenter> implements IOutCheckView {

    @BindView(R.id.bt_start)
    TextView bt_start;

    @BindView(R.id.bt_end)
    TextView bt_end;

    @BindView(R.id.bt_clean)
    TextView bt_clean;

    @BindView(R.id.bt_count)
    TextView bt_count;

    @BindView(R.id.bt_save)
    TextView bt_save;

    @BindView(R.id.dataDoneMess)
    TextView dataDoneMess;

    @BindView(R.id.outCheck_swdw_tv)
    TextView swdw_tv;

    //运输计划单
    @BindView(R.id.outCheck_ysjhd_sp)
    Spinner ysjhd_sp;

    //清单号
    @BindView(R.id.outCheck_qdh_sp)
    Spinner qdh_sp;

    //物资品称
    @BindView(R.id.outCheck_wzmc_sp)
    Spinner wzmc_sp;

    //物资号型
    @BindView(R.id.outCheck_wzhx_sp)
    Spinner wzhx_sp;

    //物资品称
    @BindView(R.id.outCheck_wzname_ck)
    CheckBox wzname_ck;

    //物资号型
    @BindView(R.id.outCheck_wzhx_ck)
    CheckBox wzhx_ck;

    //总数量
    @BindView(R.id.outCheck_num_tv)
    TextView num_tv;

    //已校验数量
    @BindView(R.id.outCheck_jynum_tv)
    TextView jynum_tv;

    //已校验数量
    @BindView(R.id.outCheck_ysjhjy_lv)
    MyListView ysjhjy_lv;

    @BindView(R.id.panel_wzjy)
    LinearLayout panel_wzjy;

    @BindView(R.id.panel_wzjytj)
    LinearLayout panel_wzjytj;

    //物资校验信息页面
    @BindView(R.id.panel_wzjyinfo)
    LinearLayout panel_wzjyinfo;

    @BindView(R.id.check_wzjyinfo_wzmc_tv)
    TextView check_wzjyinfo_wzmc_tv;

    @BindView(R.id.check_wzjyinfo_epcs_tv)
    TextView check_wzjyinfo_epcs_tv;

    @BindView(R.id.check_wzjyinfo_no_tv)
    TextView check_wzjyinfo_no_tv;

    @BindView(R.id.check_wzjyinfo_wzhxname_tv)
    TextView check_wzjyinfo_wzhxname_tv;

    @BindView(R.id.check_wzjyinfo_bzsl_tv)
    TextView check_wzjyinfo_bzsl_tv;

    @BindView(R.id.check_wzjyinfo_dtscrq_tv)
    TextView check_wzjyinfo_dtscrq_tv;

    @BindView(R.id.check_wzjyinfo_scqymc_tv)
    TextView check_wzjyinfo_scqymc_tv;

    @BindView(R.id.check_wzjyinfo_scline_tv)
    TextView check_wzjyinfo_scline_tv;

    @BindView(R.id.check_wzjyinfo_xiangNo_tv)
    TextView check_wzjyinfo_xiangNo_tv;

    @BindView(R.id.check_wzjyinfo_alreadyScan_tv)
    TextView check_wzjyinfo_alreadyScan_tv;

    @BindView(R.id.bt_wzjyinfo_lock)
    TextView bt_wzjyinfo_lock;

    @BindView(R.id.bt_wzjyinfo_lockend)
    TextView bt_wzjyinfo_lockend;

    @BindView(R.id.bt_wzjyinfo_unuse)
    TextView bt_wzjyinfo_unuse;

    @BindView(R.id.outCount_tj_lv)
    ListView tj_lv;

    @BindView(R.id.customTitleBarMain)
    CustomTitleBar customTitle;

    @BindView(R.id.scrollView)
    MyScrollView scrollView;

    private View footer;
    OutCheckListAdapter madp = null;
    OutCountAdapter tjadp = null;

    boolean isInit = false;
    boolean isFirst = false;
    JpTabFwqd fwqd = new JpTabFwqd();

    List<ProductEpc> listFormData = new ArrayList<>();//数据库中已经保存的epc数据
     String dataIsOk = "";
    private List<String> doneEpcsList = new ArrayList<>();
    JpTabFwqdjyService jpTabFwqdJyService = new JpTabFwqdjyService();
    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();
    SimpleAdapter adapter;
    boolean _isSave = true;//当前数据是否保存
    boolean lsview_ysisred = true;//校验物资标签是否扫全
    int allnum = 0;//检验记录总数
    int jynum = 0;//校验数量
    int reJynum = 0;//已校验数量
    boolean isUpload = false;//是否为载入历史数据
    private List<JpTabFwqdjy> _fwqdjyList = new ArrayList<>();
    private List<JpTabFwqd> listQdh, listWzmc, listWzhx;
    private int qdhSelect = 0;
    private int wzmcSelect = 0;
    private int wzhxSelect = 0;
    private List<String> listStrQdh, listStrYsjh, listStrWzmc, listStrWzhx;
    private ArrayAdapter<String> ysjhdh_adapter, qdh_adapter, wzmc_adapter, wzhx_adapter;
    List<ProductEpc> productMxListItems = new ArrayList<>();
    List<ProductEpc> productMxListItemsforlv = new ArrayList<>();
    Map<String, List<ProductEpc>> _productBoxMap = new HashMap<String, List<ProductEpc>>();//箱号epc(subEpc)，具体产品epc信息
    private List<ProductEpc> productMxListItemsforlvByPage = new ArrayList<>();//分页展示数据
    List<Map<String, ?>> list = new ArrayList<Map<String, ?>>();//listView  显示数据
    Map<String, JpTabFwqd> _dicFwqd = new HashMap<String, JpTabFwqd>();
    private int PageIndex = 1;
    List<JpTabFwqd> tjListBeans = new ArrayList<>();
    private int listIndex = 0;//首页点击位置
    String strMsg = "";

    ListCompositeDisposable listc = new ListCompositeDisposable();
    private boolean loadFinishFlag;
    private int startIndex;
    private int endIndex;
    private final int pageSize = 10;


    private boolean isInventory = false;

    private Handler mHandler;
    private boolean isCanceled = true;
    private int MESSAGE_SUCCESS = 0;
    private int MESSAGE_FAIL = 1;
    private String devport = "/dev/ttyMT1";
    private static final int MSG_UPDATE_LISTVIEW = 0;
    private static final int SAVE_SUCCESS = 1;
    private static final int ERROR_INFO = 2;
    private static final int SCAN_INTERVAL = 5;
    private Timer timer;

    @Override
    protected OutCheckPresenter createPresenter() {
        return new OutCheckPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_out;
    }

    /**
     * key receiver
     */
    private long startTime = 0;
    private boolean keyUpFalg = true;
    private BroadcastReceiver keyReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            int keyCode = intent.getIntExtra("keyCode", 0);
            // H941
            if (keyCode == 0) {
                keyCode = intent.getIntExtra("keycode", 0);
            }
            boolean keyDown = intent.getBooleanExtra("keydown", false);
            if (keyUpFalg && keyDown && System.currentTimeMillis() - startTime > 500) {
                keyUpFalg = false;
                startTime = System.currentTimeMillis();
                /*if (keyCode == KeyEvent.KEYCODE_F3) {
                    onClick(scan);
                }
*/
                if (keyCode == KeyEvent.KEYCODE_BACK) {
                    pageBack();
                }
                if (keyCode == KeyEvent.KEYCODE_F3 && isInventory) {
                    switch (PageIndex) {
                        case 1:
                            bt_end.performClick();
                            break;
                        case 2:
                            bt_wzjyinfo_lockend.performClick();
                            break;
                    }
                } else if (keyCode == KeyEvent.KEYCODE_F3 && !isInventory) {
                    switch (PageIndex) {
                        case 1:
                            bt_start.performClick();
                            break;
                        case 2:
                            bt_wzjyinfo_lock.performClick();
                            break;
                    }
                }
                return;
            } else if (keyDown) {
                startTime = System.currentTimeMillis();
            } else {
                keyUpFalg = true;
            }

        }
    };

    @Override
    protected void onPause() {
        super.onPause();
        unregisterReceiver(keyReceiver);
    }

    private ConnectHandler connectHandler = new ConnectHandler(this);

    private static class ConnectHandler extends Handler {
        private WeakReference<OutCheckActivity> mReference;
        private OutCheckActivity mActivity;

        ConnectHandler(OutCheckActivity activity) {
            mReference = new WeakReference<OutCheckActivity>(activity);
            mActivity = mReference.get();
        }

        @Override
        public void handleMessage(Message msg) {
            if (msg.what == mActivity.MESSAGE_SUCCESS) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_success),
                        Toast.LENGTH_SHORT).show();
            } else if (msg.what == mActivity.MESSAGE_FAIL) {
                Toast.makeText(mActivity.getApplicationContext(), mActivity.getString(R.string.port_connect_fail),
                        Toast.LENGTH_SHORT).show();
            }
            super.handleMessage(msg);
        }
    }

    @SuppressLint("ClickableViewAccessibility")
    @Override
    public void initView() {
        new UHfData(this);
        isFirst = true;
        mPresenter.getYsjhbhIsY();
        ysjhd_sp.setOnItemSelectedListener(spnysjhdhItemSelLis);
        qdh_sp.setOnItemSelectedListener(spnQdhItemSelLis);
        wzmc_sp.setOnItemSelectedListener(spnWzmcItemSelLis);
        wzhx_sp.setOnItemSelectedListener(spnWzhxItemSelLis);

        footer = getLayoutInflater().inflate(R.layout.footer, null);
        loadFinishFlag = true;
        startIndex = 0;
        endIndex = pageSize;

        madp = new OutCheckListAdapter(this, productMxListItemsforlvByPage, onClickListener);
        ysjhjy_lv.setAdapter(madp);
        ysjhjy_lv.setScrollView(scrollView);
        ysjhjy_lv.addFooterView(footer);
        ysjhjy_lv.setOnScrollListener(new ScrollListener());
        ysjhjy_lv.removeFooterView(footer);

        tjadp = new OutCountAdapter(this, tjListBeans);
        tj_lv.setAdapter(tjadp);
        setListViewHeightBasedOnChildren(tj_lv);
        customTitle.setTitleBarLeftClickListener(titleBarLeftClickListener);

        ysjhjy_lv.setOnTouchListener(new View.OnTouchListener() {
            public boolean onTouch(View v, MotionEvent event) {
                switch (event.getAction()) {
                    case MotionEvent.ACTION_DOWN:
                        scrollView.requestDisallowInterceptTouchEvent(true);
                        break;
                    case MotionEvent.ACTION_UP:
                        scrollView.requestDisallowInterceptTouchEvent(false);
                        break;
                }
                return false;
            }

        });

        mHandler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                if (isCanceled)
                    return;
                switch (msg.what) {
                    case MSG_UPDATE_LISTVIEW://数据更新

                        if (UHfData.lsTagList.size() > 0) {
                            parseData();
                        }
                        if (UHfData.mIsNew) {
                            new Thread(new Runnable() {

                                @Override
                                public void run() {
                                    if (!Util.soundfinished)
                                        Util.play(1, 0);
                                }
                            }).start();
                            UHfData.mIsNew = false;
                        }
                        break;
                    case SAVE_SUCCESS://保存成功
                        if (errList.size() > 0) {
                            String fileName = null;
                            try {
                                fileName = createXml(errList);
                                showMessage("存在重复数据，重复数据已导出到" + fileName + "位置");
                                scanFile(fileName);
                            } catch (IOException e) {
                                e.printStackTrace();
                            }
                        } else {
                            showMessage("数据保存成功");
                        }
                        madp.notifyDataSetChanged();
                        ysjhjy_lv.setAdapter(madp);
                        saveClear();
                        _isSave = true;
                        getFwqdDictionary();
                        hideWaitingDialog();
                        break;
                    case ERROR_INFO:
                        hideWaitingDialog();
                        LogUtils.e((String) msg.obj);
                        showMessage("错误:" + (String) msg.obj);
                        break;
                    default:
                        break;
                }
                super.handleMessage(msg);
            }

        };
        Util.initSoundPool(this);
    }

    @Override
    protected void onResume() {
        super.onResume();

        UHfData.lsTagList.clear();
        UHfData.dtIndexMap.clear();

        IntentFilter filter = new IntentFilter();
        filter.addAction("android.rfid.FUN_KEY");
        registerReceiver(keyReceiver, filter);
    }


    @OnClick({R.id.bt_start, R.id.bt_end, R.id.bt_save, R.id.bt_clean, R.id.bt_count, R.id.bt_wzjyinfo_unuse, R.id.bt_wzjyinfo_lock,
            R.id.bt_wzjyinfo_lockend})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.bt_start:
                startScan();
                break;
            case R.id.bt_end:
                stopScan();
                break;
            case R.id.bt_save:
                save();
                break;
            case R.id.bt_clean:
                clean();
                break;
            case R.id.bt_count:
                showTj();
                break;
            case R.id.bt_wzjyinfo_unuse:
                del();
                break;
            case R.id.bt_wzjyinfo_lock:
                lock();
                break;
            case R.id.bt_wzjyinfo_lockend:
                lockend();
                break;
        }

    }

    /**
     * 页面显示
     */
    private void panelShow(int pageIndex) {
        this.PageIndex = pageIndex;

        panel_wzjy.setVisibility(View.GONE);
        panel_wzjytj.setVisibility(View.GONE);
        panel_wzjyinfo.setVisibility(View.GONE);

        switch (pageIndex) {
            case 1:
                panel_wzjy.setVisibility(View.VISIBLE);
                panel_wzjytj.setVisibility(View.GONE);
                panel_wzjyinfo.setVisibility(View.GONE);
                break;
            case 2:
                panel_wzjy.setVisibility(View.GONE);
                panel_wzjytj.setVisibility(View.GONE);
                panel_wzjyinfo.setVisibility(View.VISIBLE);
                break;
            case 3:
                panel_wzjy.setVisibility(View.GONE);
                panel_wzjytj.setVisibility(View.VISIBLE);
                panel_wzjyinfo.setVisibility(View.GONE);
                break;
            default:
                panel_wzjy.setVisibility(View.VISIBLE);
                panel_wzjytj.setVisibility(View.GONE);
                panel_wzjyinfo.setVisibility(View.GONE);
                break;
        }

    }

    /**
     * 删除
     */
    private void del() {
        //作废当前选择中的标签，并修改显示详细列表信息和统计结果信息
        showDialog(UIUtil.getString(R.string.system_note), UIUtil.getString(R.string.del_wzinfo),
                new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        jyDelSuer();
                    }
                }, null);
    }

    /**
     * 删除确定
     */
    private void jyDelSuer() {
        try {
            JpTabFwqd fwqd = new JpTabFwqd();
            if (madp.getItem(listIndex) != null) {

                int wznum = Integer.parseInt(check_wzjyinfo_bzsl_tv.getText().toString().trim());
                int jynewnum = Integer.parseInt(jynum_tv.getText().toString().trim()) - wznum;
                jynum_tv.setText(String.valueOf(jynewnum));

                for (Map.Entry<String, JpTabFwqd> str : _dicFwqd.entrySet()) {
                    fwqd = str.getValue();
                    fwqd.setJynum(String.valueOf(Integer.parseInt(fwqd.getJynum()) - wznum));
                    fwqd.setIsOK("N");
                }
            }

            //jpTabFwqdService.inUpdate(fwqd);

            JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
            fwqdjy.setStrepc(madp.getItem(listIndex).getStrEpc().split(",")[0]);
            fwqdjy.setSubEpc(fwqdjy.getStrepc().substring(0, 41) + fwqdjy.getStrepc().substring(43, 49));
            jpTabFwqdJyService.deleteByStrEpc(fwqd, fwqdjy);

            deleteFindList(madp.getItem(listIndex).getStrEpc());

            productMxListItemsforlv.remove(listIndex);
            if (productMxListItemsforlvByPage.size() >= listIndex) {
                productMxListItemsforlvByPage.remove(listIndex);
            }
            /*
            startIndex -= 1;
            endIndex -= 1;*/
            //删除时需要修改productMxListItemsforlv的ListIndex
            int itemp = 0;
            for (ProductEpc pro : productMxListItemsforlv) {
                if (pro.getListIndex() > listIndex + 1) {
                    productMxListItemsforlv.get(itemp).setListIndex(productMxListItemsforlv.get(itemp).getListIndex() - 1);
                }
                itemp++;
            }

            madp.notifyDataSetChanged();
            ysjhjy_lv.setAdapter(madp);

            showMessage("该标签信息删除完成");
            panelShow(1);
        } catch (Exception ex) {
            LogUtils.e(ex.getMessage());
            showMessage("ERR：" + ex.getMessage());
        }

    }

    private void deleteFindList(String strEpc) {

        String[] epcs = strEpc.split(",");
        for (String epc : epcs) {
            ProductEpc foundData = null;
            for (ProductEpc pc : productMxListItems) {

                String pcepc = "";
                if (pc.getStrEpc().length() > 52) {
                    pcepc = pc.getStrEpc().split(",")[0];
                } else {
                    pcepc = pc.getStrEpc();
                }
                if (pcepc.equals(epc)) {
                    foundData = pc;
                    break;
                }
            }
            if (foundData != null) {
                productMxListItems.remove(foundData);
                doneEpcsList.remove(epc);
                _productBoxMap.remove(foundData.getStrSubEpc());
            }
            //删除时需要修改productMxListItems的ListIndex
            int itemp = 0;
            for (ProductEpc pro : productMxListItems) {
                if (pro.getListIndex() > listIndex + 1) {
                    productMxListItems.get(itemp).setListIndex(productMxListItems.get(itemp).getListIndex() - 1);
                }
                itemp++;
            }
        }
    }

    private boolean isLocked = false;

    /**
     * 锁定
     */
    private void lock() {
        isLocked = true;
        //自动降低手持机功率，根据标签唯一性，定位包装箱（当手持机距离较近时，发出相关声音），
        //同时对此包装箱新扫到的标签增加到此箱的扫到标签数，返回后，功率自动恢复原有功率
        bt_wzjyinfo_lock.setEnabled(false);
        bt_wzjyinfo_lock.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
        bt_wzjyinfo_lockend.setEnabled(true);
        bt_wzjyinfo_lockend.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
        bt_wzjyinfo_unuse.setEnabled(false);
        bt_wzjyinfo_unuse.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));

        isInventory = false;

        //设置功率
        setantpower(11);
        doTagInventory();
    }

    /**
     * 结束锁定
     */
    private void lockend() {
        isLocked = false;
        //自动降低手持机功率，根据标签唯一性，定位包装箱（当手持机距离较近时，发出相关声音），
        //同时对此包装箱新扫到的标签增加到此箱的扫到标签数，返回后，功率自动恢复原有功率
        bt_wzjyinfo_lock.setEnabled(true);
        bt_wzjyinfo_lock.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
        bt_wzjyinfo_lockend.setEnabled(false);
        bt_wzjyinfo_lockend.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
        bt_wzjyinfo_unuse.setEnabled(true);
        bt_wzjyinfo_unuse.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
        doTagInventory();
        isInventory = false;
    }

    //设置天线功率
    private void setantpower(int setPowerData) {
        try {
            //功率设置，0:表示成功。不等于0:表示失败
            int result = UHfData.UHfGetData.SetRfPower((byte) setPowerData);
            if (result == 0) {
                showMessage("功率" + setPowerData + UIUtil.getString(R.string.set_success));
            } else {
                showMessage("功率" + setPowerData + UIUtil.getString(R.string.set_fail));
            }
        } catch (Exception e) {
            LogUtils.e(e.getMessage());
            showMessage("Obtain Exception:" + e.getMessage());
            return;
        }
    }

    private void showTj() {

        if (tjadp.getCount() > 0) {
            tjListBeans.clear();
        }
        for (Map.Entry<String, JpTabFwqd> str : _dicFwqd.entrySet()) {
            JpTabFwqd fwqd = new JpTabFwqd();
            fwqd = str.getValue();
            tjListBeans.add(fwqd);
        }
        if (tjListBeans.size() > 0) {
            panelShow(3);
            tjadp.notifyDataSetChanged();
            tj_lv.setAdapter(tjadp);
            setListViewHeightBasedOnChildren(tj_lv);//高度
        } else {
            showMessage(UIUtil.getString(R.string.search_null));
        }

        /*List<JpTabFwqdBean> list = new ArrayList<>();
        for(Map.Entry<String, JpTabFwqd> str : _dicFwqd.entrySet()){
            JpTabFwqd fwqd = new JpTabFwqd();
            fwqd = str.getValue();
            JpTabFwqdBean jf = new JpTabFwqdBean();
            jf.setHx(fwqd.getHx());
            jf.setZbqmc(fwqd.getZbqmc());
            jf.setJynum(fwqd.getJynum());
            jf.setWzhxmc(fwqd.getZbqmc()+" "+fwqd.getHx());
            jf.setPmsl(fwqd.getPmsl());
            list.add(jf);
        }
        if(list.size() > 0){
            Bundle bundle = new Bundle();
            bundle.putSerializable("tjList", (Serializable) list);
            jumpToActivityTakeByAndClearTop(OutCountActivity.class,bundle);
        }else{
            showMessage(UIUtil.getString(R.string.search_null));
        }*/
    }

    @Override
    public CheckBox wzhx_ck() {
        return wzhx_ck;
    }

    @Override
    public CheckBox wzname_ck() {
        return wzname_ck;
    }

    @Override
    public List<JpTabFwqdjy> getFwqdjyList() {
        return _fwqdjyList;
    }

    @Override
    public List<ProductEpc> getProductMxListItemsforlv() {
        return productMxListItemsforlv;
    }

    @Override
    public void showYsjhdh(List<String> listYsjhdh) {
        if (listYsjhdh != null) {

            this.listStrYsjh = listYsjhdh;
            //适配器
            ysjhdh_adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, listYsjhdh);
            //设置样式
            ysjhdh_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            ysjhd_sp.setAdapter(ysjhdh_adapter);
        }
    }

    @Override
    public void showQdh(List<JpTabFwqd> list) {
        if (list != null) {

            this.listQdh = list;
            List<String> listQdhRe = new ArrayList<>();
            for (JpTabFwqd bean : list) {
                //显示Qdh
                listQdhRe.add(bean.getQdh());
            }

            this.listStrQdh = listQdhRe;
            //适配器
            qdh_adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, listQdhRe);
            //设置样式
            qdh_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            qdh_sp.setAdapter(qdh_adapter);
        }


    }

    @Override
    public void showWzmc(List<JpTabFwqd> list) {
        if (list != null) {
            this.listWzmc = list;
            List<String> listWzmcRe = new ArrayList<>();
            for (JpTabFwqd bean : list) {
                //显示Zbqmc
                listWzmcRe.add(bean.getZbqmc());
            }

            this.listStrWzmc = listWzmcRe;
            //适配器
            wzmc_adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, listWzmcRe);
            //设置样式
            wzmc_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            wzmc_sp.setAdapter(wzmc_adapter);
        }

    }

    @Override
    public void showWzhx(List<JpTabFwqd> list) {
        if (list != null) {
            this.listWzhx = list;
            List<String> listWzhxRe = new ArrayList<>();
            for (JpTabFwqd bean : list) {
                //显示HX
                listWzhxRe.add(bean.getHx());
            }

            this.listStrWzhx = listWzhxRe;
            //适配器
            wzhx_adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, listWzhxRe);
            //设置样式
            wzhx_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            wzhx_sp.setAdapter(wzhx_adapter);
        }

    }

    private Spinner.OnItemSelectedListener spnysjhdhItemSelLis = new Spinner.OnItemSelectedListener() {
        public void onItemSelected(AdapterView parent, View v, int position, long id) {
            if (null != listStrYsjh && listStrYsjh.size() > 0) {
                String strYsjhdh = parent.getSelectedItem().toString();
                fwqd.setYsjhbh(strYsjhdh);
                //showWaitingDialog("获取运输计划详情...");
                showQdh(null);
                mPresenter.getCbox_qdhValue(strYsjhdh);
            } else {
                showYsjhdh(null);
                showQdh(null);
                showWzmc(null);
                showWzhx(null);
            }
            scrollView.scrollTo(0, 0);

        }

        public void onNothingSelected(AdapterView parent) {
            //null
        }
    };

    private Spinner.OnItemSelectedListener spnQdhItemSelLis = new Spinner.OnItemSelectedListener() {
        public void onItemSelected(AdapterView parent, View v, int position, long id) {
            if (null != listStrQdh && listStrQdh.size() > 0) {
                String strQdh = parent.getSelectedItem().toString();
                //填写指定收物单位
                qdhSelect = position;
                swdw_tv.setText(listQdh.get(position).getSwdwmc());
                fwqd.setQdh(strQdh);
                fwqd.setSwdwmc(listQdh.get(position).getSwdwmc());

                mPresenter.getCbox_wzmcValue(fwqd);
            } else {
                showWzmc(null);
                showWzhx(null);
                fwqd.setQdh("");
                fwqd.setSwdwmc("");
            }

            scrollView.scrollTo(0, 0);
        }

        public void onNothingSelected(AdapterView parent) {
            //null
        }
    };

    private Spinner.OnItemSelectedListener spnWzmcItemSelLis = new Spinner.OnItemSelectedListener() {
        public void onItemSelected(AdapterView parent, View v, int position, long id) {

            if (null != listStrWzmc && listStrWzmc.size() > 0) {
                String strWzmc = parent.getSelectedItem().toString();

                wzmcSelect = position;
                fwqd.setWzdm(listWzmc.get(position).getWzdm());
                fwqd.setZbqmc(listWzmc.get(position).getZbqmc());

                showWzhx(null);
                mPresenter.getCbox_wzhxValue(fwqd);
            } else {
                showWzhx(null);
                fwqd.setWzdm("");
                fwqd.setZbqmc("");
            }
            scrollView.scrollTo(0, 0);

        }

        public void onNothingSelected(AdapterView parent) {
            //null
        }
    };

    private Spinner.OnItemSelectedListener spnWzhxItemSelLis = new Spinner.OnItemSelectedListener() {
        public void onItemSelected(AdapterView parent, View v, int position, long id) {
            if (null != listStrWzhx && listStrWzhx.size() > 0) {
                String strWzhx = parent.getSelectedItem().toString();
                wzhxSelect = position;
                fwqd.setHx(strWzhx);
                fwqd.setLsm(listWzhx.get(position).getLsm());
                getFwqdDictionary();
                /*Disposable subscribe = Observable.interval(1, TimeUnit.SECONDS)
                        .doOnNext(integer -> getFwqdDictionary())
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe(integer -> {
                            hideWaitingDialog();
                        }, Throwable::printStackTrace);*/
                /*addDis(Observable.interval(1, TimeUnit.SECONDS)
                        .doOnNext(integer -> getFwqdDictionary())
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe(integer -> {
                            hideWaitingDialog();
                        }, Throwable::printStackTrace));*/
            } else {
                showWzhx(null);
            }
            scrollView.scrollTo(0, 0);

        }
        public void onNothingSelected(AdapterView parent) {
            //null
        }
    };

    private void addDis(Disposable dis) {
        listc.add(dis);
    }

    /**
     * 按清单扫描
     */
    public void wznameChanged(View v) {
        try {
            if (madp.getCount() > 0) {
                if (!_isSave) {
                    String title = UIUtil.getString(R.string.system_note);
                    String message = UIUtil.getString(R.string.change_scanType_is_saveDate);
                    showDialog(title, message, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            wzjyDataSave();

                            //清空listview数据
                            //_dicFwqd.clear();
                            _productBoxMap.clear();
                            productMxListItems.clear();
                            productMxListItemsforlv.clear();
                            productMxListItemsforlvByPage.clear();
                            startIndex = 0;
                            endIndex = pageSize;
                            madp.notifyDataSetChanged();
                            ysjhjy_lv.setAdapter(madp);

                            changeWzmcInit();
                        }
                    }, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {

                            //清空listview数据
                            //_dicFwqd.clear();
                            _productBoxMap.clear();
                            productMxListItems.clear();
                            productMxListItemsforlv.clear();
                            productMxListItemsforlvByPage.clear();
                            startIndex = 0;
                            endIndex = pageSize;
                            madp.notifyDataSetChanged();
                            ysjhjy_lv.setAdapter(madp);

                            changeWzmcInit();
                        }
                    });

                } else {
                    changeWzmcInit();
                }
            } else {
                changeWzmcInit();
            }
        } catch (Exception ex) {
            LogUtils.e(ex.getMessage());
            showMessage("ERR：" + ex.getMessage());
        }
    }

    private void changeWzmcInit() {
        if (wzname_ck.isChecked()) {//按照清单盘点
            wzhx_ck.setChecked(false);

            if (listStrQdh != null && listStrQdh.size() > 0) {
                fwqd.setQdh(listStrQdh.get(qdhSelect));
                fwqd.setSwdwmc(listQdh.get(qdhSelect).getSwdwmc());
                mPresenter.getCbox_wzmcValue(fwqd);
            }
        } else {//取消按照清单盘点
            wzhx_ck.setChecked(true);
            if (listStrWzhx != null && listStrWzhx.size() > 0) {
                fwqd.setHx(listStrWzhx.get(wzhxSelect));
                fwqd.setLsm(listWzhx.get(wzhxSelect).getLsm());
                getFwqdDictionary();
            }

        }
    }

    /**
     * 按物资号型扫描
     */
    public void wzhxCheckChanged(View v) {

        try {
            if (madp.getCount() > 0) {
                if (!_isSave) {
                    String title = UIUtil.getString(R.string.system_note);
                    String message = UIUtil.getString(R.string.change_scanType_is_saveDate);
                    showDialog(title, message, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            wzjyDataSave();
                            //清空listview数据
                            _productBoxMap.clear();
                            productMxListItemsforlv.clear();
                            productMxListItemsforlvByPage.clear();
                            startIndex = 0;
                            endIndex = pageSize;
                            productMxListItems.clear();
                            madp.notifyDataSetChanged();

                            changeWzhxInit();

                        }
                    }, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            //清空listview数据
                            _productBoxMap.clear();
                            productMxListItemsforlv.clear();
                            productMxListItemsforlvByPage.clear();
                            startIndex = 0;
                            endIndex = pageSize;
                            productMxListItems.clear();
                            madp.notifyDataSetChanged();
                            changeWzhxInit();

                        }
                    });

                } else {
                    changeWzhxInit();
                }
            } else {
                changeWzhxInit();
            }
        } catch (Exception ex) {
            LogUtils.e(ex.getMessage());
            showMessage("ERR：" + ex.getMessage());
        }
    }

    private void changeWzhxInit() {
        if (wzhx_ck.isChecked()) {//按照物资号型盘点
            wzname_ck.setChecked(false);
            if (listStrWzhx != null && listStrWzhx.size() > 0) {
                fwqd.setHx(listStrWzhx.get(wzhxSelect));
                fwqd.setLsm(listWzhx.get(wzhxSelect).getLsm());
                getFwqdDictionary();
            }
        } else {//取消按照物资号型盘点
            wzname_ck.setChecked(true);
            if (listStrQdh != null && listStrQdh.size() > 0) {
                fwqd.setQdh(listStrQdh.get(qdhSelect));
                fwqd.setSwdwmc(listQdh.get(qdhSelect).getSwdwmc());
                mPresenter.getCbox_wzmcValue(fwqd);
            }
        }
    }


    private void startScan() {
        try {
            setantpower(UserCache.getAntPower());
            ysjhjy_lv.setFocusable(false);
            swdw_tv.setFocusable(true);
            swdw_tv.setFocusableInTouchMode(true);
            swdw_tv.requestFocus();
            isInventory = false;
            doTagInventory();
            showMessage(UIUtil.getString(R.string.start_scan));

            this.bt_start.setEnabled(false);
            this.bt_start.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
            this.bt_end.setEnabled(true);
            this.bt_end.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
            this.bt_clean.setEnabled(false);
            this.bt_clean.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
            this.bt_save.setEnabled(false);
            this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
            this.bt_count.setEnabled(false);
            this.bt_count.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
        } catch (Exception ex) {
            LogUtils.e(ex.getMessage());
            showMessage("ERR：" + ex.getMessage());
        }
    }

    private void stopScan() {
        try {
            doTagInventory();
            isInventory = false;
            showMessage(UIUtil.getString(R.string.stop_scan));
            //showlist();
            this.bt_start.setEnabled(true);
            this.bt_start.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
            this.bt_end.setEnabled(false);
            this.bt_end.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
            this.bt_clean.setEnabled(true);
            this.bt_clean.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
            this.bt_save.setEnabled(true);
            this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
            this.bt_count.setEnabled(true);
            this.bt_count.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
        } catch (Exception ex) {
            LogUtils.e(ex.getMessage());
            showMessage("ERR：" + ex.getMessage());
        }
    }

    public void doTagInventory() {
        isInventory = !isInventory;
        if (timer == null && isInventory) {//盘点开始
            if (madp != null) {
                mHandler.removeMessages(MSG_UPDATE_LISTVIEW);
                mHandler.sendEmptyMessage(MSG_UPDATE_LISTVIEW);
            }
            isCanceled = false;
            timer = new Timer();
            timer.schedule(new TimerTask() {
                @Override
                public void run() {
                    UHfData.Inventory_6c(255, 0);//0单标签，1多标签；255自动；是否盘存TID，0—否，1—是，值为1时盘存到的为标签的TID
//						UHfData.Inventory_6c_Mask((byte)0, 16, 0, UHfGetData.hexStringToBytes("E200"));
                    mHandler.removeMessages(MSG_UPDATE_LISTVIEW);
                    mHandler.sendEmptyMessage(MSG_UPDATE_LISTVIEW);
                }
            }, 0, SCAN_INTERVAL);
            showMessage("正在盘点");
        } else {//盘点停止
            isCanceled = true;
            if (timer != null) {
                timer.cancel();
                timer = null;
                showMessage("结束盘点");
            }
        }
    }

    /**
     *
     */
    private void save() {
        isReadAll();
        wzjySave();
    }

    /**
     * 清空页面扫描信息
     */
    private void clean() {
        if (madp.getCount() > 0) {
            String title = UIUtil.getString(R.string.system_note);
            String message = "是否清空未保存的检验数据?";
            showDialog(title, message, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    getFwqdDictionary();
                    showMessage(UIUtil.getString(R.string.cleaned));
                    UHfData.lsTagList.clear();
                    UHfData.dtIndexMap.clear();//清除累计的数据
                    //showlist();
                }
            }, null);
        } else {
            showMessage(UIUtil.getString(R.string.no_epc_scan));
        }

    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN) {
            pageBack();
            return true;
        }
        if (event.getScanCode() == 261 && isInventory) {
            switch (PageIndex) {
                case 1:
                    bt_end.performClick();
                    break;
                case 2:
                    bt_wzjyinfo_lockend.performClick();
                    break;
            }
        } else if (event.getScanCode() == 261 && !isInventory) {
            switch (PageIndex) {
                case 1:
                    bt_start.performClick();
                    break;
                case 2:
                    bt_wzjyinfo_lock.performClick();
                    break;
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    private void pageBack() {
        switch (PageIndex) {
            case 1:
                if (madp.getCount() > 0) {
                    if (!_isSave) {
                        showDialog("系统提示", "你有校验数据未保存，是否保存？", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                try {
                                    if (!wzjySave()) {
                                        dialog.cancel();
                                        return;
                                    }
                                } catch (Exception e) {
                                    LogUtils.e(e.getMessage());
                                    showMessage("Err:" + e.getMessage());
                                }

                            }
                        }, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                jumpToActivity(MainActivity.class);
                            }
                        });
                    } else {
                        jumpToActivity(MainActivity.class);
                    }
                } else {
                    jumpToActivity(MainActivity.class);
                }
                break;
            case 2:
                if (isLocked) {
                    lockend();//解除锁定
                }
                panelShow(1);
                break;
            case 3:
                //stopScan();
                panelShow(1);
                break;
        }
    }


    /**
     * 标签是否扫全
     */
    private void isReadAll() {
        for (ProductEpc item : productMxListItemsforlv) {
            if (lsview_ysisred) {
                if (item.getIbqs() < item.getiZbAll()) {
                    lsview_ysisred = false;
                }
            }
        }
    }


    /**
     * 重新获取发物清单序列
     */
    long first;

    private void getFwqdDictionaryDetail() {
        showWaitingDialog("获取发物清单序列");
        addDis(Observable.interval(1, TimeUnit.SECONDS)
                .doOnNext(integer -> getFwqdDictionaryDetail())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(integer -> {
                    if(listFormData.size()>0){
                        for(ProductEpc pp : listFormData){
                            LoadProductTolist(pp,"N");
                        }
                    }
                    hideWaitingDialog();
                }, Throwable::printStackTrace));
    }

    private void getFwqdDictionary() {
        showWaitingDialog("获取发物清单序列");
        first = System.currentTimeMillis();
        doneEpcsList.clear();
        tagListSize = 0;
        ListIndex = 0;
        if (isInventory) bt_end.performClick();

        try {
            _dicFwqd.clear();
            _productBoxMap.clear();
            productMxListItems.clear();
            productMxListItemsforlv.clear();
            productMxListItemsforlvByPage.clear();
            startIndex = 0;
            endIndex = pageSize;
            madp.notifyDataSetChanged();
            ysjhjy_lv.setAdapter(madp);

            saveClear();
            mPresenter.getFwqdDictionary(fwqd);

        } catch (Exception e) {
            LogUtils.e(e.getMessage());
            showMessage("Err:" + e.getMessage());
        }
    }

    private void saveClear() {
        jynum_tv.setText("0");
        allnum = 0;
        jynum = 0;
        lsview_ysisred = true;
    }


    /**
     * 获取检验记录号序号列
     */
    @Override
    public void getFwqdDictonary(List<JpTabFwqd> listBeans) {
        try {
            if (listBeans.size() > 0) {
                String tmpLsm = "";
                JpTabFwqd fwqdr = new JpTabFwqd();
                isUpload = true;
                for (JpTabFwqd fwqd : listBeans) {
                    fwqdr = fwqd;
                    allnum += Integer.parseInt(fwqd.getPmsl());
                    jynum += Integer.parseInt(fwqd.getJynum());
                    _dicFwqd.put(fwqd.getLsm(), fwqd);
                    //tmpLsm += fwqd.getLsm() + ",";getFwqdDictonary
                    tmpLsm = fwqd.getLsm();
                    isUpload = true;
                    JpTabFwqd finalFwqdr = fwqdr;
                    String finalTmpLsm = tmpLsm;
                    addDis(Observable.just(1)
                            .doOnNext(integer ->
                                    mPresenter.getFwqdjyInfo(_fwqdjyList, finalFwqdr, finalTmpLsm, "N"))
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribeOn(Schedulers.io())//执行在io线程
                            .subscribe(integer -> {
                                runOnUiThread(new Runnable() {
                                    @Override
                                    public void run() {
                                        //回主线程
                                        if(listFormData.size()>0){
                                            for(ProductEpc pp : listFormData){
                                                LoadProductTolist(pp,"N");
                                            }
                                        }
                                        isUpload = false;
                                        num_tv.setText(String.valueOf(allnum));
                                        jynum_tv.setText(String.valueOf(jynum));
                                        ysjhjy_lv.setFocusable(false);
                                        swdw_tv.setFocusable(true);
                                        swdw_tv.setFocusableInTouchMode(true);
                                        swdw_tv.requestFocus();
                                        hideWaitingDialog();
                                    }
                                });

                            }, Throwable::printStackTrace));
                    //载入未扫全数据
                    /*_fwqdjyList.clear();
                    long current = System.currentTimeMillis();
                    Log.e("数据库查询耗时", String.valueOf(current - first));
                    mPresenter.getFwqdjyInfo(_fwqdjyList, fwqdr, tmpLsm, "N");

                    long now = System.currentTimeMillis();
                    Log.e("查询所有数据耗时N", String.valueOf(now - current));
                    mPresenter.getFwqdjyData(_fwqdjyList, "N");
                    long now1 = System.currentTimeMillis();
                    Log.e("加载所有数据耗时N", String.valueOf(now1 - now));

                    //载入扫全数据
                    _fwqdjyList.clear();
                    mPresenter.getFwqdjyInfo(_fwqdjyList, fwqdr, tmpLsm, "Y");
                    mPresenter.getFwqdjyData(_fwqdjyList, "Y");
                    long now2 = System.currentTimeMillis();
                    Log.e("加载所有数据耗时Y", String.valueOf(now2 - now1));
                    Log.e("总耗时Y", String.valueOf(now2 - current));
                    isUpload = false;*/
                }
                //tmpLsm = tmpLsm.substring(0,tmpLsm.length()-1);
                //tmpLsm += ")";

                //isUpload = false;
                /*num_tv.setText(String.valueOf(allnum));
                jynum_tv.setText(String.valueOf(jynum));
                ysjhjy_lv.setFocusable(false);
                swdw_tv.setFocusable(true);
                swdw_tv.setFocusableInTouchMode(true);
                swdw_tv.requestFocus();*/
            }
            //hideWaitingDialog();
        } catch (Exception e) {
            //LogUtils.e(e.getMessage());
            showMessage("Err:" + e.getMessage());
            //hideWaitingDialog();
        }

    }


    public void LoadProductTolist(ProductEpc pro, String isOk) {

        //数据有变化，保存状态变化
        if (!isUpload) _isSave = false;

        //判断是否已经存在
        ProductEpc foundData = null;
        List<ProductEpc> foundList = new ArrayList<>();
        if (_productBoxMap.containsKey(pro.getStrSubEpc())) {//找到指定物资箱号的所有epc数据
            boolean isHere = true;//此epc是否已经存在
            foundList = _productBoxMap.get(pro.getStrSubEpc());
            //之前处理过此物资的此箱号
            if (foundList.get(0).getStrEpc().contains(pro.getStrEpc())) {
                return;
            } else {
                //箱号记录已经存在
                pro.setListIndex(_productBoxMap.get(pro.getStrSubEpc()).get(0).getListIndex());
                if (isOk.equals("N")) {
                    _productBoxMap.get(pro.getStrSubEpc()).add(pro);
                    listViewMxUpdate(pro);
                }
            }
            /*for(ProductEpc p : foundList){
                String epc = "";
                if(p.getStrEpc().length()>52){
                    epc = p.getStrEpc().split(",")[0];
                }else{
                    epc = p.getStrEpc();
                }
                if(pro.getStrEpc().equals(epc)){//epc已经存在 不处理
                    return;
                }else{//epc不存在
                    isHere = false;
                }
            }*/
            /*if(!isHere){
                //箱号记录已经存在
                pro.setListIndex(_productBoxMap.get(pro.getStrSubEpc()).get(0).getListIndex());
                if(isOk.equals("N")){
                    _productBoxMap.get(pro.getStrSubEpc()).add(pro);
                    listViewMxUpdate(pro);
                }
            }*/
        } else {//之前没有处理到该物资未找到指定箱号，新数据，添加数据
            showIsScan(pro, isOk);
        }
        /*for(ProductEpc p : productMxListItemsforlv){
            String epc = "";
            if(p.getStrEpc().length()>52){
                epc = p.getStrEpc().split(",")[0];
            }else{
                epc = p.getStrEpc();
            }
            if(pro.getStrEpc().equals(epc)){
                return;
            }else{
                if(p.isSameBox(pro.getStrEpc())){
                    foundData = p;
                    break;
                }
            }
        }
        if(foundData == null){
            //Log.e("识别epc",pro.getStrEpc() );
            //之前没有处理到该物资
            //pro.setListIndex( ysjhjy_lv.getCount() + 1) ;
            pro.setListIndex( productMxListItemsforlv.size() + 1) ;

            JpTabFwqd jp = _dicFwqd.get(String.valueOf(pro.getiWzLsm()));
            //JpTabFwqd jp = _dicFwqd.get(pro.getStrWzLsm());
            int tmpPmsl = Integer.parseInt(jp.getPmsl());
            int tmpJynum = Integer.parseInt(jp.getJynum());

            if(isUpload || tmpPmsl >=tmpJynum + pro.getiNum()){
                listViewMxAdd(pro ,isOk);
            }
        }else{
            //记录已经存在
            pro.setListIndex(foundData.getListIndex());
            if(isOk.equals("N")){
                listViewMxUpdate(pro);
            }
        }*/
        //showlist(pro,isOk);

    }

    public void showIsScan(ProductEpc pro, String isOk) {
        pro.setListIndex(productMxListItemsforlv.size() + 1);
        List<ProductEpc> boxEpclist = new ArrayList<>();
        boxEpclist.add(pro);
        _productBoxMap.put(pro.getStrSubEpc(), boxEpclist);
        //Log.e(pro.getStrXiangNo()+"新增时ListIndex", String.valueOf(pro.getListIndex()));
        JpTabFwqd jp = _dicFwqd.get(String.valueOf(pro.getiWzLsm()));
        //JpTabFwqd jp = _dicFwqd.get(pro.getStrWzLsm());
        int tmpPmsl = Integer.parseInt(jp.getPmsl());
        int tmpJynum = Integer.parseInt(jp.getJynum());

        if (isUpload || tmpPmsl >= tmpJynum + pro.getiNum()) {
            listViewMxAdd(pro, isOk);
        }
    }

    /**
     * 当一箱贴有多张标签的时候，同一箱的标签显示在一条记录上，更新校验数，把epc记录下来
     */
    public void listViewMxUpdate(ProductEpc pro) {
        productMxListItems.add(pro);
        try {
            if (madp.data.size() > 0) {
                //ProductEpc pp = madp.getItem(pro.getListIndex() -1);  //页面未全部加载的时候列表数据不全，不能取这个值作为编号
                ProductEpc pp = productMxListItemsforlv.get(pro.getListIndex() - 1);
                int tempBqs = pp.getIbqs() + 1;
                if (tempBqs > 4) {
                    tempBqs = 4;
                } else {
                    String strEpc = pp.getStrEpc();
                    strEpc += "," + pro.getStrEpc();
                    productMxListItemsforlv.get(pro.getListIndex() - 1).setStrEpc(strEpc);


                    String strNoAndAll = pp.getStrZbAndAll();
                    strNoAndAll += "、" + String.valueOf(pro.getiZbNo()) + "/" + String.valueOf(pro.getiZbAll());
                    productMxListItemsforlv.get(pro.getListIndex() - 1).setStrZbAndAll(strNoAndAll);

                    /*if(productMxListItemsforlvByPage.size() >= pro.getListIndex()){//只更新页面展示的数据
                        productMxListItemsforlvByPage.get(pro.getListIndex() -1).setStrEpc(strEpc);
                        productMxListItemsforlvByPage.get(pro.getListIndex() -1).setStrZbAndAll(strNoAndAll);
                    }*/

                }
                productMxListItemsforlv.get(pro.getListIndex() - 1).setIbqs(tempBqs);
                productMxListItemsforlv.get(pro.getListIndex() - 1).setStrBqs(String.valueOf(tempBqs) + "/" + String.valueOf(pro.getiZbAll()));

                if (pro.getiZbAll() == tempBqs) {
                /*LinearLayout layout = (LinearLayout)ysjhjy_lv.getChildAt(pro.getListIndex() -1);
                LinearLayout outCheck_ly = (LinearLayout) layout.findViewById(R.id.outCheck_ly);
                outCheck_ly.setBackgroundColor(UIUtil.getColor(R.color.white));*/
                    lsview_ysisred = true;
                }
                if (productMxListItemsforlv.size() < 11) {
                    productMxListItemsforlvByPage.clear();
                    productMxListItemsforlvByPage.addAll(productMxListItemsforlv);
                } else {
                    /*if(productMxListItemsforlvByPage.size() >= pro.getListIndex()){
                        productMxListItemsforlvByPage.get(pro.getListIndex() -1).setIbqs(tempBqs);
                        productMxListItemsforlvByPage.get(pro.getListIndex() -1).setStrBqs(String.valueOf(tempBqs) + "/" + String.valueOf(pro.getiZbAll()));
                    }*/
                }
                if (productMxListItemsforlvByPage.size() >= pro.getListIndex()) {
                    madp.updataView(pro.getListIndex() - 1, ysjhjy_lv, productMxListItemsforlvByPage.get(pro.getListIndex() - 1));
                }
                /*madp.notifyDataSetChanged();
                ysjhjy_lv.setAdapter(madp);*/

                if (PageIndex == 2) {
                    check_wzjyinfo_alreadyScan_tv.setText(productMxListItemsforlv.get(pro.getListIndex() - 1).getStrZbAndAll());
                }
            }

        } catch (Exception e) {
            //LogUtils.e(e.getMessage());
            //showMessage("listViewMxUpdate Err:"+e.getMessage());
        }
    }

    @Override
    public List<ProductEpc> getListFormData() {
        return listFormData;
    }

    @Override
    public void getListFromData(List<ProductEpc> listFromData, String isOk) {
        listFormData.clear();
        listFormData.addAll(listFromData);
        dataIsOk = isOk;
    }

    /**
     * 对首次出现的箱，在listview中增加一条记录
     */
    public void listViewMxAdd(ProductEpc pro, String isOk) {
        productMxListItems.add(pro);
        try {
            if (isOk.equals("N")) {//只显示未扫全的数据
                pro.getWZHXInfo();
                if (pro.getiZbAll() == 1) {
                    lsview_ysisred = true;
                } else {
                    lsview_ysisred = false;
                }
                pro.setStrWzHXName(pro.getStrWzName() + pro.getStrWzHXName());
                pro.setIbqs(1);
                pro.setStrBqs("1/" + String.valueOf(pro.getiZbAll()));
                pro.setStrZbAndAll(String.valueOf(pro.getiZbNo()) + "/" + String.valueOf(pro.getiZbAll()));

                productMxListItemsforlv.add(pro);
                if (productMxListItemsforlv.size() < 11) {
                    productMxListItemsforlvByPage.clear();
                    productMxListItemsforlvByPage.addAll(productMxListItemsforlv);
                    madp.notifyDataSetChanged();
                    ysjhjy_lv.setAdapter(madp);
                }
                setWzjyNum(pro);//新读到一箱物资就计数
            }

        } catch (Exception e) {
            //LogUtils.e(e.getMessage());
            showMessage("listview 更新 Err:" + e.getMessage());
        }
    }

    /**
     * 物资校验数量设置
     */
    private void setWzjyNum(ProductEpc pro) {

        if (!isUpload) {
            if (_dicFwqd.size() > 0) {
                if (_dicFwqd.containsKey(String.valueOf(pro.getiWzLsm()))) {
                    //if(_dicFwqd.containsKey(pro.getStrWzLsm())){
                    int tmpJynum = Integer.parseInt(_dicFwqd.get(String.valueOf(pro.getiWzLsm())).getJynum());
                    _dicFwqd.get(String.valueOf(pro.getiWzLsm())).setJynum(String.valueOf(tmpJynum + pro.getiNum()));
                }
            }
        }
        int jynum = pro.getiNum() + Integer.parseInt(jynum_tv.getText().toString().trim());
        jynum_tv.setText(String.valueOf(jynum));
    }

    /**
     * 物资校验信息保存
     */
    private boolean wzjySaveresult = false;

    private boolean wzjySave() {
        //boolean blresult = false;
        if (madp.getCount() > 0) {
            if (!lsview_ysisred) {
                showDialog("系统提示", "存在没扫全的标签，是否确定进行保存？", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        try {
                            dialog.dismiss();
                            wzjySaveresult = wzjyDataSave();
                        } catch (Exception e) {
                            LogUtils.e(e.getMessage());
                            showMessage("Err:" + e.getMessage());
                        }

                    }
                }, null);
            } else {
                wzjySaveresult = wzjyDataSave();
            }
        } else {
            showMessage("没有需要保存的数据");
        }
        return wzjySaveresult;
    }

    /**
     * 标签校验数据保存
     */
    private boolean wzjyDataSave() {
        showWaitingDialog("标签校验数据保存中...");
        showMessage("标签校验数据保存中...");
        boolean blresult = false;
        if (isInventory) bt_end.performClick();
        //int i = madp.getCount();
        //增加
        //saveThread.start();
        if (productMxListItemsforlv.size() == 0) {
            showMessage("当前并无可操作的数据");
        }else{
            bt_save.setEnabled(false);
            this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
            addDis(Observable.just(1)
                    .doOnNext(integer ->
                            saveFwqdjyInfo1())
                    .observeOn(AndroidSchedulers.mainThread())
                    .subscribeOn(Schedulers.io())//执行在io线程
                    .subscribe(integer -> {
                        runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                if (errList.size() > 0) {
                                    String fileName = null;
                                    try {
                                        fileName = createXml(errList);
                                        showMessage("存在重复数据，重复数据已导出到" + fileName + "位置");
                                        scanFile(fileName);
                                    } catch (IOException e) {
                                        e.printStackTrace();
                                    }
                                } else {
                                    showMessage("数据保存成功");
                                }
                                //回主线程
                                bt_save.setEnabled(true);
                                bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
                                madp.notifyDataSetChanged();
                                ysjhjy_lv.setAdapter(madp);
                                saveClear();
                                _isSave = true;
                                hideWaitingDialog();
                                getFwqdDictionary();
                            }
                        });
                    }, Throwable::printStackTrace));
        }

        /*saveFwqdjyInfo1();
        saveFwqqdInfo();

        saveClear();
         _isSave = true;
        getFwqdDictionary();*/

        //hideWaitingDialog();
        blresult = true;
        return blresult;
    }

    /**
     * 保存物资校验信息
     */
    private void saveFwqdjyInfo() {
        bt_save.setEnabled(false);
        this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
        //showWaitingDialog(UIUtil.getString(R.string.save_fwqdjyInfo_now));
        try {
            List<Product_fwqd> errList = new ArrayList<>();
            long current = System.currentTimeMillis();
            if (productMxListItemsforlv.size() == 0) {
                showMessage("当前并无可操作的数据");
                bt_save.setEnabled(true);
                this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
                return;
            }
            for (int i = productMxListItemsforlv.size() - 1; i >= 0; i--) {
                Log.e("insert", "--------------------进度" + i);
                JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
                JpTabFwqd fwqd = new JpTabFwqd();
                String[] epcs = productMxListItemsforlv.get(i).getStrEpc().split(",");
                ProductEpc founfData = new ProductEpc();
                for (ProductEpc pc : productMxListItems) {
                    String epc = "";
                    if (pc.getStrEpc().length() > 52) {
                        epc = pc.getStrEpc().split(",")[0];
                    } else {
                        epc = pc.getStrEpc();
                    }
                    if (epc.equals(epcs[0])) {
                        founfData = pc;
                    }
                }
                fwqd = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                //fwqd = _dicFwqd.get(founfData.getStrWzLsm());

                if (founfData != null) {
                    fwqdjy.setQydwdm(fwqd.getQydwdm());
                    fwqdjy.setSubEpc(epcs[0].substring(0, 41) + epcs[0].substring(43, 49));
                    fwqdjy = getfwqdjy(fwqdjy, epcs);
                    if (productMxListItemsforlv.get(i).getIbqs() < productMxListItemsforlv.get(i).getiZbAll()) {
                        fwqdjy.setIsOk("N");
                    } else {
                        fwqdjy.setIsOk("Y");
                    }
                    fwqdjy.setGznd(fwqd.getGznd());
                    fwqdjy.setYsjhbh(fwqd.getYsjhbh());
                    fwqdjy.setJsdwdm(fwqd.getJsdwdm());
                    fwqdjy.setSwdwdm(fwqd.getSwdwdm());
                    fwqdjy.setQdh(fwqd.getQdh());

                    fwqdjy.setDtpdate(TimeUtil.getDate());
                    fwqdjy.setLsm(String.valueOf(founfData.getiWzLsm()));
                    fwqdjy.setPmsl(String.valueOf(founfData.getiNum()));
                    fwqdjy.setIsOut("N");
                }

                productMxListItemsforlv.remove(i);
                Log.e("remove", "--------------------进度" + i);
                if (productMxListItemsforlvByPage.size() >= i + 1) {
                    productMxListItemsforlvByPage.remove(i);
                }

                //刷新数据
                madp.notifyDataSetChanged();
                ysjhjy_lv.setAdapter(madp);

                int itemp = 0;
                for (ProductEpc pc : productMxListItems) {
                    if (pc.getListIndex() > i + 1) {
                        //  --
                        productMxListItems.get(itemp).setListIndex(productMxListItems.get(itemp).getListIndex() - 1);
                    }
                    itemp++;
                }

                //判断是否已经在数据库清单里面
                List<JpTabFwqdjy> listFwqd = jpTabFwqdJyService.isNew(fwqdjy, true);
                if (listFwqd.size() > 0) {
                    //清单里面存在此epc update
                    jpTabFwqdJyService.update(fwqdjy);
                } else if (listFwqd.size() == 0) {
                    //清单里面不存在此epc
                    List<JpTabFwqdjy> listFwqdF = jpTabFwqdJyService.isNew(fwqdjy, false);
                    if (listFwqdF.size() > 0) {
                        //在与其他清单号中
                        Product_fwqd pro_fwqd = new Product_fwqd();
                        pro_fwqd.setOldYsjhbh(listFwqdF.get(0).getYsjhbh());
                        pro_fwqd.setOldQdh(listFwqdF.get(0).getQdh());
                        pro_fwqd.set_fwqd(fwqd);
                        pro_fwqd.set_pro(founfData);
                        errList.add(pro_fwqd);

                        JpTabFwqd ss = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                        ss.setJynum(String.valueOf(Integer.parseInt(ss.getJynum()) - founfData.getiNum()));
                    } else {
                        //数据库中没有此epc insert
                        jpTabFwqdJyService.insert(fwqdjy);
                    }
                }
            }

            //物资校验数据表更新
            if (errList.size() > 0) {
                String fileName = createXml(errList);
                showMessage("存在重复数据，重复数据已导出到" + fileName + "位置");
                scanFile(fileName);
            } else {
                showMessage("数据保存成功");
            }
            Log.e("耗时", String.valueOf(System.currentTimeMillis() - current));
            bt_save.setEnabled(true);
            this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));

        } catch (Exception e) {
            LogUtils.e(e.getMessage());
            showMessage("Err:" + e.getMessage());
            Log.e("remove", "--------------------进度" + e.getMessage());

            bt_save.setEnabled(true);
            this.bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
        }
        hideWaitingDialog();

    }

    List<Product_fwqd> errList = new ArrayList<>();
    private void saveFwqdjyInfo1() {
        errList.clear();
        //showWaitingDialog(UIUtil.getString(R.string.save_fwqdjyInfo_now));
        try {
            List<JpTabFwqdjy> JpTabFwqdjy_insert = new ArrayList<>();

            for (int i = productMxListItemsforlv.size() - 1; i >= 0; i--) {
                //Log.e("insert", "--------------------进度" + i);
                JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
                JpTabFwqd fwqd = new JpTabFwqd();
                String[] epcs = productMxListItemsforlv.get(i).getStrEpc().split(",");
                ProductEpc founfData = new ProductEpc();
                for (ProductEpc pc : productMxListItems) {
                    String epc = "";
                    if (pc.getStrEpc().length() > 52) {
                        epc = pc.getStrEpc().split(",")[0];
                    } else {
                        epc = pc.getStrEpc();
                    }
                    if (epc.equals(epcs[0])) {
                        founfData = pc;
                    }
                }
                fwqd = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                //fwqd = _dicFwqd.get(founfData.getStrWzLsm());

                if (founfData != null) {
                    fwqdjy.setQydwdm(fwqd.getQydwdm());
                    fwqdjy.setSubEpc(epcs[0].substring(0, 41) + epcs[0].substring(43, 49));
                    fwqdjy = getfwqdjy(fwqdjy, epcs);
                    if (productMxListItemsforlv.get(i).getIbqs() < productMxListItemsforlv.get(i).getiZbAll()) {
                        fwqdjy.setIsOk("N");
                    } else {
                        fwqdjy.setIsOk("Y");
                    }
                    fwqdjy.setGznd(fwqd.getGznd());
                    fwqdjy.setYsjhbh(fwqd.getYsjhbh());
                    fwqdjy.setJsdwdm(fwqd.getJsdwdm());
                    fwqdjy.setSwdwdm(fwqd.getSwdwdm());
                    fwqdjy.setQdh(fwqd.getQdh());
                    Date day=new Date();
                    fwqdjy.setDtpdate(TimeUtil.getDate());
                    fwqdjy.setLsm(String.valueOf(founfData.getiWzLsm()));
                    fwqdjy.setPmsl(String.valueOf(founfData.getiNum()));
                    fwqdjy.setIsOut("N");
                }

                productMxListItemsforlv.remove(i);
                if (productMxListItemsforlvByPage.size() >= i + 1) {
                    productMxListItemsforlvByPage.remove(i);
                }

                int itemp = 0;
                for (ProductEpc pc : productMxListItems) {
                    if (pc.getListIndex() > i + 1) {
                        //  --
                        productMxListItems.get(itemp).setListIndex(productMxListItems.get(itemp).getListIndex() - 1);
                    }
                    itemp++;
                }

                //判断是否已经在数据库清单里面
                List<JpTabFwqdjy> listFwqd = jpTabFwqdJyService.isNew(fwqdjy, true);
                if (listFwqd.size() > 0) {
                    //清单里面存在此epc update
                    jpTabFwqdJyService.update(fwqdjy);
                } else if (listFwqd.size() == 0) {
                    //清单里面不存在此epc
                    List<JpTabFwqdjy> listFwqdF = jpTabFwqdJyService.isNew(fwqdjy, false);
                    if (listFwqdF.size() > 0) {
                        //在与其他清单号中
                        Product_fwqd pro_fwqd = new Product_fwqd();
                        pro_fwqd.setOldYsjhbh(listFwqdF.get(0).getYsjhbh());
                        pro_fwqd.setOldQdh(listFwqdF.get(0).getQdh());
                        pro_fwqd.set_fwqd(fwqd);
                        pro_fwqd.set_pro(founfData);
                        errList.add(pro_fwqd);

                        JpTabFwqd ss = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                        ss.setJynum(String.valueOf(Integer.parseInt(ss.getJynum()) - founfData.getiNum()));
                    } else {
                        //数据库中没有此epc insert
                        //jpTabFwqdJyService.insert(fwqdjy);
                        JpTabFwqdjy_insert.add(fwqdjy);
                    }
                }
            }

            if (JpTabFwqdjy_insert.size() > 0) {
                if (jpTabFwqdJyService.insert(JpTabFwqdjy_insert)) {
                    saveFwqqdInfo();
                }
            }
            //物资校验数据表更新
            /*Message msg =Message.obtain();
            msg.what = SAVE_SUCCESS;   //保存成功
            mHandler.sendMessage(msg);*/
        } catch (Exception e) {
            Message msg =Message.obtain();
            msg.obj = e.getMessage();
            msg.what = ERROR_INFO;   //失败信息
            mHandler.sendMessage(msg);
        }
        //hideWaitingDialog();
    }

    Thread saveThread = new Thread(new Runnable() {
        @Override
        public void run() {
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    //回主线程
                    bt_save.setEnabled(false);
                    bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green_un));
                }
            });
            //showWaitingDialog(UIUtil.getString(R.string.save_fwqdjyInfo_now));
            try {
                List<JpTabFwqdjy> JpTabFwqdjy_insert = new ArrayList<>();
                List<Product_fwqd> errList = new ArrayList<>();

                if (productMxListItemsforlv.size() == 0) {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            //回主线程
                            showMessage("当前并无可操作的数据");
                            bt_save.setEnabled(true);
                            bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
                        }
                    });
                    return;
                }

                /*long current = System.currentTimeMillis();
                for (Map.Entry<String, List<ProductEpc>> entry : _productBoxMap.entrySet()) {
                    System.out.println("key= " + entry.getKey() + " and value= " + entry.getValue());
                    *//*List<String> epcList = new ArrayList<>();
                    for(ProductEpc proEpc : entry.getValue()){
                        epcList.add(proEpc.getStrEpc());
                    }*//*
                    JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
                    JpTabFwqd fwqd = new JpTabFwqd();
                    String[] epcs = entry.getValue().get(0).getStrEpc().split(",");
                    fwqd = _dicFwqd.get(String.valueOf(entry.getValue().get(0).getiWzLsm()));
                    fwqdjy.setQydwdm(fwqd.getQydwdm());
                    fwqdjy.setSubEpc(entry.getKey());
                    fwqdjy = getfwqdjy(fwqdjy,epcs);
                    if(entry.getValue().size() < entry.getValue().get(0).getiZbAll()){//当前读取到的指定物资箱号epc数量小于应读取标签总数量（单标签1多标签4）
                        fwqdjy.setIsOk("N");
                    }else{
                        fwqdjy.setIsOk("Y");
                    }
                    fwqdjy.setGznd(fwqd.getGznd());
                    fwqdjy.setYsjhbh(fwqd.getYsjhbh());
                    fwqdjy.setJsdwdm(fwqd.getJsdwdm());
                    fwqdjy.setSwdwdm(fwqd.getSwdwdm());
                    fwqdjy.setQdh(fwqd.getQdh());

                    fwqdjy.setDtpdate(TimeUtil.getDate());
                    fwqdjy.setLsm(String.valueOf(entry.getValue().get(0).getiWzLsm()));
                    fwqdjy.setPmsl(String.valueOf(entry.getValue().get(0).getiNum()));
                    fwqdjy.setIsOut("N");

                    //遍历指定物资箱号下面的所有epc
                    for(ProductEpc founfData : entry.getValue()){
                        //判断是否已经在数据库清单里面
                        List<JpTabFwqdjy> listFwqd = jpTabFwqdJyService.isNew(fwqdjy,true);
                        if(listFwqd.size() > 0){
                            //清单里面存在此epc update
                            jpTabFwqdJyService.update(fwqdjy);
                        }else{
                            //清单里面不存在此epc
                            List<JpTabFwqdjy> listFwqdF = jpTabFwqdJyService.isNew(fwqdjy,false);
                            if(listFwqdF.size() > 0){
                                //在与其他清单号中
                                Product_fwqd pro_fwqd = new Product_fwqd();
                                pro_fwqd.setOldYsjhbh(listFwqdF.get(0).getYsjhbh());
                                pro_fwqd.setOldQdh(listFwqdF.get(0).getQdh());
                                pro_fwqd.set_fwqd(fwqd);
                                pro_fwqd.set_pro(founfData);
                                errList.add(pro_fwqd);
                                JpTabFwqd ss =  _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                                ss.setJynum(String.valueOf(Integer.parseInt(ss.getJynum()) - founfData.getiNum()));
                            }else{
                                //数据库中没有此epc insert
                                jpTabFwqdJyService.insert(fwqdjy);
                                //JpTabFwqdjy_insert.add(fwqdjy);
                            }
                        }

                    }


                }

                Log.e("数据库查询耗时", String.valueOf(System.currentTimeMillis() - current));*/

                for (int i = productMxListItemsforlv.size() - 1; i >= 0; i--) {
                    //Log.e("insert", "--------------------进度" + i);
                    JpTabFwqdjy fwqdjy = new JpTabFwqdjy();
                    JpTabFwqd fwqd = new JpTabFwqd();
                    String[] epcs = productMxListItemsforlv.get(i).getStrEpc().split(",");
                    ProductEpc founfData = new ProductEpc();
                    for (ProductEpc pc : productMxListItems) {
                        String epc = "";
                        if (pc.getStrEpc().length() > 52) {
                            epc = pc.getStrEpc().split(",")[0];
                        } else {
                            epc = pc.getStrEpc();
                        }
                        if (epc.equals(epcs[0])) {
                            founfData = pc;
                        }
                    }
                    fwqd = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                    //fwqd = _dicFwqd.get(founfData.getStrWzLsm());

                    if (founfData != null) {
                        fwqdjy.setQydwdm(fwqd.getQydwdm());
                        fwqdjy.setSubEpc(epcs[0].substring(0, 41) + epcs[0].substring(43, 49));
                        fwqdjy = getfwqdjy(fwqdjy, epcs);
                        if (productMxListItemsforlv.get(i).getIbqs() < productMxListItemsforlv.get(i).getiZbAll()) {
                            fwqdjy.setIsOk("N");
                        } else {
                            fwqdjy.setIsOk("Y");
                        }
                        fwqdjy.setGznd(fwqd.getGznd());
                        fwqdjy.setYsjhbh(fwqd.getYsjhbh());
                        fwqdjy.setJsdwdm(fwqd.getJsdwdm());
                        fwqdjy.setSwdwdm(fwqd.getSwdwdm());
                        fwqdjy.setQdh(fwqd.getQdh());

                        fwqdjy.setDtpdate(TimeUtil.getDate());
                        fwqdjy.setLsm(String.valueOf(founfData.getiWzLsm()));
                        fwqdjy.setPmsl(String.valueOf(founfData.getiNum()));
                        fwqdjy.setIsOut("N");
                    }

                    productMxListItemsforlv.remove(i);
                    //Log.e("remove", "--------------------进度" + i);
                    if (productMxListItemsforlvByPage.size() >= i + 1) {
                        productMxListItemsforlvByPage.remove(i);
                    }

                    int itemp = 0;
                    for (ProductEpc pc : productMxListItems) {
                        if (pc.getListIndex() > i + 1) {
                            //  --
                            productMxListItems.get(itemp).setListIndex(productMxListItems.get(itemp).getListIndex() - 1);
                        }
                        itemp++;
                    }

                    //判断是否已经在数据库清单里面
                    List<JpTabFwqdjy> listFwqd = jpTabFwqdJyService.isNew(fwqdjy, true);
                    if (listFwqd.size() > 0) {
                        //清单里面存在此epc update
                        jpTabFwqdJyService.update(fwqdjy);
                    } else if (listFwqd.size() == 0) {
                        //清单里面不存在此epc
                        List<JpTabFwqdjy> listFwqdF = jpTabFwqdJyService.isNew(fwqdjy, false);
                        if (listFwqdF.size() > 0) {
                            //在与其他清单号中
                            Product_fwqd pro_fwqd = new Product_fwqd();
                            pro_fwqd.setOldYsjhbh(listFwqdF.get(0).getYsjhbh());
                            pro_fwqd.setOldQdh(listFwqdF.get(0).getQdh());
                            pro_fwqd.set_fwqd(fwqd);
                            pro_fwqd.set_pro(founfData);
                            errList.add(pro_fwqd);

                            JpTabFwqd ss = _dicFwqd.get(String.valueOf(founfData.getiWzLsm()));
                            ss.setJynum(String.valueOf(Integer.parseInt(ss.getJynum()) - founfData.getiNum()));
                        } else {
                            //数据库中没有此epc insert
                            //jpTabFwqdJyService.insert(fwqdjy);
                            JpTabFwqdjy_insert.add(fwqdjy);
                        }
                    }
                }

                if (JpTabFwqdjy_insert.size() > 0) {
                    if (jpTabFwqdJyService.insert(JpTabFwqdjy_insert)) {
                        saveFwqqdInfo();
                    }
                }
                //saveFwqqdInfo();
                //物资校验数据表更新
                if (errList.size() > 0) {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            //回主线程
                            String fileName = null;
                            try {
                                fileName = createXml(errList);
                                showMessage("存在重复数据，重复数据已导出到" + fileName + "位置");
                                scanFile(fileName);
                            } catch (IOException e) {
                                e.printStackTrace();
                                showMessage("存在重复数据，导出重复数据出错！");
                                LogUtil.e(e.getMessage());
                            }
                        }
                    });
                } else {
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            //回主线程
                            showMessage("数据保存成功");
                        }
                    });
                }
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        //回主线程
                        bt_save.setEnabled(true);
                        bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
                    }
                });
                //mHandler.sendEmptyMessage(SAVE_SUCCESS);
            } catch (Exception e) {

                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        //LogUtils.e(e.getMessage());
                        showMessage("Err:" + e.getMessage());
                        Log.e("remove", "--------------------进度" + e.getMessage());
                        //回主线程
                        bt_save.setEnabled(true);
                        bt_save.setBackground(UIUtil.getDrawable(R.drawable.btn_back_green));
                    }
                });
            }
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    //回主线程
                    //刷新数据
                    madp.notifyDataSetChanged();
                    ysjhjy_lv.setAdapter(madp);
                    saveClear();
                    _isSave = true;
                    getFwqdDictionary();
                    hideWaitingDialog();
                }
            });
        }
    });

    /**
     * 触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
     *
     * @param fileName
     */
    public void scanFile(String fileName) {
        //触发扫描 mtp下的文件，在保存文件到 sd卡下后，不能显示，故这里触发一下扫描机制，让手机连上电脑后，就可以读出文件了
        MediaScannerConnection.scanFile(this, new String[]{fileName}, new String[]{"application/octet-stream"}, new MediaScannerConnection.OnScanCompletedListener() {
            @Override
            public void onScanCompleted(final String path, final Uri uri) {
                //your file has been scanned!
            }
        });
    }

    private JpTabFwqdjy getfwqdjy(JpTabFwqdjy fwqdjy, String[] epcs) {
        switch (epcs.length) {
            case 1:
                fwqdjy.setStrepc(epcs[0]);
                fwqdjy.setStrepc1(",");
                fwqdjy.setStrepc2(",");
                fwqdjy.setStrepc3(",");
                break;
            case 2:
                fwqdjy.setStrepc(epcs[0]);
                fwqdjy.setStrepc1(epcs[1]);
                fwqdjy.setStrepc2(",");
                fwqdjy.setStrepc3(",");
                break;
            case 3:
                fwqdjy.setStrepc(epcs[0]);
                fwqdjy.setStrepc1(epcs[1]);
                fwqdjy.setStrepc2(epcs[2]);
                fwqdjy.setStrepc3(",");
                break;
            case 4:
                fwqdjy.setStrepc(epcs[0]);
                fwqdjy.setStrepc1(epcs[1]);
                fwqdjy.setStrepc2(epcs[2]);
                fwqdjy.setStrepc3(epcs[3]);
                break;
            default:
                fwqdjy.setStrepc(",");
                fwqdjy.setStrepc1(",");
                fwqdjy.setStrepc2(",");
                fwqdjy.setStrepc3(",");
                break;
        }
        return fwqdjy;
    }

    /**
     * 更新发物清单数据信息
     */
    private void saveFwqqdInfo() {
        try {
            /*for (String key : _dicFwqd.keySet()){

            }*/
            for (Map.Entry<String, JpTabFwqd> str : _dicFwqd.entrySet()) {
                JpTabFwqd fwqd = new JpTabFwqd();
                fwqd = str.getValue();
                if (fwqd.getPmsl().equals(fwqd.getJynum())) {
                    fwqd.setIsOK("Y");
                } else {
                    fwqd.setIsOK("N");
                }
                jpTabFwqdService.inUpdate(fwqd);
            }

        } catch (Exception e) {
            //LogUtils.e(e.getMessage());
            //showMessage("Err:" + e.getMessage());
        }


    }

    int tagListSize = 0;//个数
    int ListIndex = 0;

    /**
     * 解析数据
     */
    private void parseData() {
        isUpload = false;
        int doSize = 0;//个数
        try {//UHfData.lsTagList
            String epcstr = "";//epc
            if (UHfData.lsTagList.size() > tagListSize) {//读到的标签数量>已经处理的标签数
                doSize = UHfData.lsTagList.size() - tagListSize;//等待处理的epc数量 = 读到的标签数 - 已经处理的标签数
                //LogUtils.e("需要处理的doSize--" + doSize +"--读到的标签数lsTagList--"+ UHfData.lsTagList.size()+"--已经处理的标签数tagListSize"+tagListSize);
                tagListSize = UHfData.lsTagList.size();//已经处理的标签数 = 读到的标签数
                //LogUtils.e("读到的标签数lsTagList--"+ UHfData.lsTagList.size()+"--已经处理的标签数tagListSize"+tagListSize);
            }
            if (doSize > 0)
                while (doSize > 0) {
                    //if (index < 2000) {
                    epcstr = UHfData.lsTagList.get(ListIndex).strEPC;
                    epcstr = epcstr.replace(" ", "");
                    //LogUtils.e("ListIndex--"+ ListIndex+"---epc:" + epcstr);
                    //epcstr = "0504000D2491001486033C4772AA11110000A077D04190730700";
                    //已经处理的epc列表中不包含这个
                    //if(!doneEpcsList.contains(epcstr)){
                    if (epcstr.length() == 52 && epcstr.substring(0, 2).equals("05")) {
                        ProductEpc product = new ProductEpc();
                        product.setStrEpc(epcstr);
                        product.getInfoFormEpc();
                        if (product.getStrEpc().substring(0, 2).equals("05") && product.getStrTagType().equals("1") && !product.getStrNum().equals("000")) {
                            tagMethod(product);
                            doneEpcsList.add(epcstr);
                            //LogUtils.e("ListIndex--"+ ListIndex+"---有效的epc:" + epcstr);
                        }
                    }

                    //}
                    //index ++;
                    // }
                    ListIndex++;
                    doSize--;
                }

            //刷新数据
            madp.notifyDataSetChanged();
            ysjhjy_lv.setAdapter(madp);

        } catch (Exception e) {
            showMessage(e.getMessage());
            e.printStackTrace();
            LogUtils.e(e.getMessage());
        }
        if (!isInventory)
            showMessage(UIUtil.getString(R.string.wait_todo));

    }

    /**
     * 显示扫描到的标签信息
     */
    private void tagMethod(ProductEpc pro) {
        ProductEpc foundData = null;
        /*for(ProductEpc pe : productMxListItems ){

            String epc = "";
            if(pe.getStrEpc().length()>52){
                epc = pe.getStrEpc().split(",")[0];
            }else{
                epc = pe.getStrEpc();
            }
            if(epc.equals(pro.getStrEpc()) ){
                foundData = pe;
                break;
            }
        }*/
        //if(foundData == null){
        if (!doneEpcsList.contains(pro.getStrEpc())) {

            //之前没有扫描到
            try {
                if (pro.getStrTagType().equals("1")) {
                    switch (PageIndex) {
                        case 1:
                            //如果扫描到的标签物资代码和号型代码与锁定的物资代码一致则处理，否则放弃
                            if (wzname_ck.isChecked() || wzhx_ck.isChecked()) {
                                String X = String.valueOf(pro.getiWzLsm());
                                if (_dicFwqd.containsKey(String.valueOf(pro.getiWzLsm()))) {
                                    //if(_dicFwqd.containsKey(pro.getStrWzLsm())){
                                    //在发物清单序列内的物资都能识别
                                    LoadProductTolist(pro, "N");
                                }
                            } else {
                                if (String.valueOf(pro.getiWzLsm()).equals(fwqd.getLsm())) {
                                    //仅能识别一个发物清单的品名号型
                                    LoadProductTolist(pro, "N");
                                }
                                /*if(pro.getStrWzLsm().equals(fwqd.getLsm())){
                                    //仅能识别一个发物清单的品名号型
                                    LoadProductTolist(pro,"N");
                                }*/
                            }
                            break;
                        case 2:
                            String proLsm = String.valueOf(pro.getiWzLsm());
                            String wzLsm = check_wzjyinfo_wzhxname_tv.getTag().toString().trim();
                            String proXiang = String.valueOf(pro.getiXangNo());
                            String wzXiang = check_wzjyinfo_xiangNo_tv.getText().toString().trim();
                            if ((proLsm).equals(wzLsm)
                                    && proXiang.equals(wzXiang)
                                    && String.valueOf(pro.getiScxNo()).equals(check_wzjyinfo_scline_tv.getText().toString().trim())
                                    && TimeUtil.getDateStringShort(pro.getDtScrq()).equals(check_wzjyinfo_dtscrq_tv.getText().toString().trim())
                            ) {
                                LoadProductTolist(pro, "N");
                            }
                            break;
                    }


                }
            } catch (Exception e) {

                LogUtils.e(e.getMessage());
                showMessage("Err:" + e.getMessage());
            }
        } else {
            try {
                if (PageIndex == 2) {
                    if (String.valueOf(pro.getiWzLsm()).equals(check_wzjyinfo_wzhxname_tv.getTag().toString().trim())
                            && String.valueOf(pro.getiXangNo()).equals(check_wzjyinfo_xiangNo_tv.getText().toString().trim())
                            && String.valueOf(pro.getiScxNo()).equals(check_wzjyinfo_scline_tv.getText().toString().trim())
                            && TimeUtil.getDateStringShort(pro.getDtScrq()).equals(check_wzjyinfo_dtscrq_tv.getText().toString().trim())
                    ) {

                    }
                }

            } catch (Exception e) {
                LogUtils.e(e.getMessage());
                showMessage("Err:" + e.getMessage());
            }
        }

    }

    private View.OnClickListener onClickListener = new View.OnClickListener() {

        @Override
        public void onClick(View view) {
            LinearLayout btn = (LinearLayout) view;

            int pos = (Integer) btn.getTag();
            listIndex = pos;
            for (int i = 0; i < productMxListItemsforlv.size(); i++) {
                if (pos == i) {
                    ProductEpc pro = new ProductEpc();
                    pro.setStrEpc(madp.getItem(pos).getStrEpc().split(",")[0]);
                    pro.getInfoFormEpc();
                    if (pro.getStrTagType().equals("1")) {
                        pro.getSCCSInfo();
                        pro.getWZHXInfo();
                        if (pro.getStrWzHXName().equals("")) {
                            pro.setStrWzHXName("NULL");
                        }
                        if (pro.getStrSCCSName().equals("")) {
                            pro.setStrSCCSName("NULL");
                        }
                        check_wzjyinfo_wzmc_tv.setText(pro.getStrWzName());
                        check_wzjyinfo_wzhxname_tv.setText(pro.getStrWzHXName());
                        check_wzjyinfo_wzhxname_tv.setTag(String.valueOf(pro.getiWzLsm()));
                        check_wzjyinfo_scqymc_tv.setText(pro.getStrSCCSName().equals("NULL") ? "" : pro.getStrSCCSName());
                        check_wzjyinfo_scline_tv.setText(String.valueOf(pro.getiScxNo()));

                        check_wzjyinfo_bzsl_tv.setText(String.valueOf(pro.getiNum()));
                        check_wzjyinfo_dtscrq_tv.setText(TimeUtil.getDateStringShort(madp.getItem(pos).getDtScrq()));

                        check_wzjyinfo_xiangNo_tv.setText(String.valueOf(pro.getiXangNo()));
                        check_wzjyinfo_alreadyScan_tv.setText(madp.getItem(pos).getStrZbAndAll());
                        panelShow(2);
                    }

                }
            }
        }
    };

    //返回按钮事件
    private View.OnClickListener titleBarLeftClickListener = new View.OnClickListener() {

        @Override
        public void onClick(View view) {
            pageBack();
        }
    };

    public final class ScrollListener implements AbsListView.OnScrollListener {
        boolean isLastRow = false;

        @Override
        public void onScrollStateChanged(AbsListView view, int scrollState) {
            //LogUtils.e("---->" + scrollState);
            switch (scrollState) {
                case SCROLL_STATE_IDLE://滚到底部
                    /*if(view.getLastVisiblePosition() == (view.getCount() - 1)){
                        ysjhjy_lv.setNotAllowParentScroll(false);
                        scrollView.setAllowChildViewScroll(true);
                    }*/
                    if (isLastRow) {//已经停止
                        showMessage("");
                        if (view.getCount() < productMxListItemsforlv.size()) {//没有加载全部数据的时候
                            LogUtils.e("startIndex，endIndex" + Integer.toString(startIndex) + Integer.toString(endIndex));
                            ysjhjy_lv.addFooterView(footer);
                            startIndex += pageSize;
                            endIndex += pageSize;
                            LogUtils.e("新增后展示startIndex，endIndex" + Integer.toString(startIndex) + Integer.toString(endIndex));
                            LogUtils.e("展示数量：" + Integer.toString(productMxListItemsforlvByPage.size()));
                            productMxListItemsforlvByPage.addAll(getDataService(startIndex, endIndex));
                            LogUtils.e("新增后展示数量：" + Integer.toString(productMxListItemsforlvByPage.size()));
                            madp.notifyDataSetChanged();
                            ysjhjy_lv.removeFooterView(footer);
                            dataDoneMess.setText("");
                        } else {
                            dataDoneMess.setText("数据已经加载完全！");
                            showMessage("数据已经加载完全！");
                        }
                       /* Message message = handler.obtainMessage(0x123, getDataService(startIndex, endIndex));
                        message.sendToTarget();*/
                        isLastRow = false;
                    }
                    break;
                case SCROLL_STATE_TOUCH_SCROLL://手点击屏幕准备滑动时
                    productMxListItems.size();
                    productMxListItemsforlv.size();
                    productMxListItemsforlvByPage.size();
                    break;
                case SCROLL_STATE_FLING://手指离开屏幕瞬间被触发，在滚动停止时结束

                    break;
            }
            //当滚动到最后一行且停止滚动时，执行加载


        }

        @Override
        public void onScroll(AbsListView view, int firstVisibleItem, int visibleItemCount, int totalItemCount) {
            if (firstVisibleItem + visibleItemCount == totalItemCount && totalItemCount > 0) {
                isLastRow = true;
            }

        }

    }

    /**
     * 加载显示数据
     *
     * @param from
     * @param to
     * @return
     */
    public List<ProductEpc> getDataService(int from, int to) {
        List<ProductEpc> getDatalist = new ArrayList<>();
        if (to > productMxListItemsforlv.size()) {
            to = productMxListItemsforlv.size();
            endIndex = to;
            startIndex = to - 10;
        }
        for (int i = from; i < to; i++) {
            getDatalist.add(productMxListItemsforlv.get(i));
        }
        LogUtils.d("加载数据：" + Integer.toString(productMxListItemsforlvByPage.size()));
        return getDatalist;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //线程清空
        listc.clear();
    }

}

