package com.junmp.print.ui.matcheck.out.outcheck;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.ProductEpcBean;
import com.junmp.print.ui.matcheck.random.CheckRandomAdapter;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/5/31
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class OutCheckListAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;
    private View.OnClickListener onClickListener;

    public List<ProductEpc> data;

    public OutCheckListAdapter(Context context, List<ProductEpc> data,
                                  View.OnClickListener onClickListener) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.onClickListener = onClickListener;
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public ProductEpc getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_out_item, null);

            holder = new ViewHolder();

            holder.wzpmhx_tv = convertView.findViewById(R.id.outCheck_wzpmhx_tv);
            holder.xh_tv = convertView.findViewById(R.id.outCheck_xh_tv);
            holder.num_tv = convertView.findViewById(R.id.outCheck_num_tv);
            holder.data_tv = convertView.findViewById(R.id.outCheck_data_tv);
            holder.outCheck_ly = convertView.findViewById(R.id.outCheck_ly);
            holder.epc_tv = convertView.findViewById(R.id.outCheck_epc_tv);
            holder.wzlsm_tv = convertView.findViewById(R.id.outCheck_wzlsm_tv);
            holder.zbno_tv = convertView.findViewById(R.id.outCheck_noAndAll_tv);

            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        ProductEpc mInfo = data.get(position);

        if (mInfo != null) {

            holder.wzpmhx_tv.setText(mInfo.getStrWzHXName());
            if(mInfo.getStrBzType().equals("F")){
                holder.xh_tv.setText("混" + String.valueOf(mInfo.getiXangNo()));
            }else{
                holder.xh_tv.setText(String.valueOf(mInfo.getiXangNo()));
            }
            holder.num_tv.setText(mInfo.getStrBqs());
            holder.data_tv.setText(TimeUtil.getDateStringShort(mInfo.getDtScrq()));

            holder.epc_tv.setText(mInfo.getStrEpc());
            holder.wzlsm_tv.setText(mInfo.getStrWzLsm());
            holder.zbno_tv.setText(mInfo.getStrZbAndAll());

           if(mInfo.getIbqs() < mInfo.getiZbAll()){
               holder.outCheck_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
           }else{
               holder.outCheck_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
           }
           /* int[] colors = {Color.WHITE, Color.rgb(219, 238, 244)};//RGB颜色 Color.rgb(219, 238, 244)
            convertView.setBackgroundColor(colors[position % 2]);// 每隔item之间颜色不同*/
            // 通常将position设置为tag，方便之后判断点击的是哪一个
            holder.outCheck_ly.setTag(position);
            holder.outCheck_ly.setOnClickListener(this.onClickListener);
        }

        return convertView;
    }

    static class ViewHolder {
        TextView wzpmhx_tv,xh_tv,num_tv,data_tv,epc_tv,wzlsm_tv,zbno_tv;
        LinearLayout outCheck_ly;
    }
    public void updataView(int posi, ListView listView, ProductEpc mInfo) {
        int visibleFirstPosi = listView.getFirstVisiblePosition();
        int visibleLastPosi = listView.getLastVisiblePosition();
        if (posi >= visibleFirstPosi && posi <= visibleLastPosi) {
            View view = listView.getChildAt(posi - visibleFirstPosi);
            ViewHolder holder = (ViewHolder) view.getTag();

            if (mInfo != null) {

                holder.wzpmhx_tv.setText(mInfo.getStrWzHXName());
                if(mInfo.getStrBzType().equals("F")){
                    holder.xh_tv.setText("混" + String.valueOf(mInfo.getiXangNo()));
                }else{
                    holder.xh_tv.setText(String.valueOf(mInfo.getiXangNo()));
                }
                holder.num_tv.setText(mInfo.getStrBqs());
                holder.data_tv.setText(TimeUtil.getDateStringShort(mInfo.getDtScrq()));

                holder.epc_tv.setText(mInfo.getStrEpc());
                holder.wzlsm_tv.setText(mInfo.getStrWzLsm());
                holder.zbno_tv.setText(mInfo.getStrZbAndAll());

                if(mInfo.getIbqs() < mInfo.getiZbAll()){
                    holder.outCheck_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
                }else{

                }
                data.set(posi, mInfo);
            }
        }
    }

}



