package com.junmp.print.ui.matcheck.out.outcount;

import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.JpTabFwqdBean;
import com.junmp.print.dao.entity.JpTabWzjyBean;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/1
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class OutCountAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;

    public List<JpTabFwqd> data;

    public OutCountAdapter(Context context, List<JpTabFwqd> data) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Object getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_out_count_item, null);

            holder = new ViewHolder();

            holder.wzhxmc_tv = convertView.findViewById(R.id.outCount_wzhxmc_tv);
            holder.pmsl_tv = convertView.findViewById(R.id.outCount_pmsl_tv);
            holder.jynum_tv = convertView.findViewById(R.id.outCount_jynum_tv);
            holder.item_ly = convertView.findViewById(R.id.outCount_item_ly);

            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        JpTabFwqd mInfo = data.get(position);

        if (mInfo != null) {

            holder.wzhxmc_tv.setText(mInfo.getZbqmc()+" "+mInfo.getHx());
            holder.pmsl_tv.setText(mInfo.getPmsl());
            holder.jynum_tv.setText(mInfo.getJynum());

            if(Integer.parseInt(mInfo.getPmsl()) > Integer.parseInt(mInfo.getJynum()) ){
                holder.item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }else{
                holder.item_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
            }

        }

        return convertView;
    }

    static class ViewHolder {

        TextView wzhxmc_tv;

        TextView pmsl_tv;

        TextView jynum_tv;

        LinearLayout item_ly;
    }

}
