package com.junmp.print.ui.matcheck.plan.importplan;

import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.util.Xml;
import android.view.View;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.entity.TabBzglWzdm;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.iview.ITfImportView;
import com.junmp.print.presenter.TfImportPresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.util.LogUtil;
import com.junmp.print.util.LogUtils;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.VersionUtils;
import com.junmp.print.view.HorizontalProgressBar;
import com.junmp.print.view.progress.NumberProgressBar;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：运输计划导入
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfImportActivity extends BaseActivity<ITfImportView,TfImportPresenter> implements ITfImportView {

    @BindView(R.id.bt_tf_import)
    TextView bt_import;

    @BindView(R.id.numberbar)
    NumberProgressBar bnp;

    Boolean parse = false;//是否正在解析

    JpTabFwqdService fwqdService = new JpTabFwqdService();

    @Override
    protected TfImportPresenter createPresenter() {
        return new TfImportPresenter(this);
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_transferplan_import;
    }

    @Override
    public void initView() {
        bnp.setOnProgressBarListener(this::onProgressChange);
        bnp.setReachedBarHeight(10);
        bnp.setUnreachedBarHeight(10);
        bnp.setProgressTextSize(15);
    }
    @Override
    public void onStop() {
        super.onStop();
        parse = false;
    }
    @OnClick({R.id.bt_tf_import})
    public void onViewClick(View view){
        switch (view.getId()) {
              //“运输计划导入”
            case R.id.bt_tf_import:
                importYsjh();
                break;
        }
    }

    private void importYsjh() {
        parse = true;
        bnp.setProgress(0);
        bt_import.setBackgroundColor(UIUtil.getColor(R.color.green_bt_unEnable));
        bt_import.setEnabled(false);
        Thread myThread = new Thread(new Runnable() {
            @Override
            public void run() {
                parse();
                //做完以后
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        //回主线程
                        bt_import.setBackgroundColor(UIUtil.getColor(R.color.green_bt));
                        bt_import.setEnabled(true);
                    }
                });
            }
        });
        myThread.start();
    }

    boolean isSuccess = true;
    File file;
    private void parse() {
        file = new File(Environment.getExternalStorageDirectory() + "/JPQYHand/Update/VIE_BZGL_FWQD.xml");
        Message msg = new Message();
        try {
            FileInputStream fis = new FileInputStream(file);
            //获取Xml的pull解析器
            XmlPullParser xp = Xml.newPullParser();

            //指定使用什么编码去解析xml文件
            xp.setInput(fis,"gb2312");

            //开始解析
            //需要判断当前解析到什么标签，因为解析到不同的标签需要做不同的操作
            //通过获取当前标签的事件类型
            int type = xp.getEventType();
            JpTabFwqd fwqd = null;
            List<JpTabFwqd> fwqdList = null;
            LogUtils.e("读取xml开始"+TimeUtil.getDateLongNo());
            int num = 0;
            int all = 0;
            while (type!=XmlPullParser.END_DOCUMENT){
                switch (type) {
                    case XmlPullParser.START_TAG:
                        if ("list".equals(xp.getName())) {//获取当前标签的名字
                            fwqdList = new ArrayList<>();
                        } else if ("results".equals(xp.getName())) {//获取当前标签的名字
                            all = Integer.valueOf(xp.nextText());
                            int finalAll = all;
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    bnp.setMax(finalAll);
                                }
                            });
                        }else if ("VIE__BZGL__FWQD".equals(xp.getName())) {//获取当前标签的名字
                            fwqd = new JpTabFwqd();
                            num = num + 1;
                        }else if ("gznd".equals(xp.getName())) {
                            String gznd = xp.nextText();
                            fwqd.setGznd(gznd);
                        } else if ("qydwdm".equals(xp.getName())) {
                            String qydwdm = xp.nextText();
                            fwqd.setQydwdm(qydwdm);
                        } else if ("qydwmc".equals(xp.getName())) {
                            String qydwmc = xp.nextText();
                            fwqd.setQydwmc(qydwmc);
                        } else if ("ysjhbh".equals(xp.getName())) {
                            String ysjhbh = xp.nextText();//获取当前节点的下一个节点的文本，并把指针移动至当前节点的结束节点
                            fwqd.setYsjhbh(ysjhbh);
                        } else if ("qdh".equals(xp.getName())) {
                            String qdh = xp.nextText();
                            fwqd.setQdh(qdh);
                        }else if ("swdwdm".equals(xp.getName())) {
                            String swdwdm = xp.nextText();
                            fwqd.setSwdwdm(swdwdm);
                        }else if ("swdwmc".equals(xp.getName())) {
                            String swdwmc = xp.nextText();
                            fwqd.setSwdwmc(swdwmc);
                        }else if ("jsdwdm".equals(xp.getName())) {
                            String jsdwdm = xp.nextText();
                            fwqd.setJsdwdm(jsdwdm);
                        }else if ("jsdwmc".equals(xp.getName())) {
                            String jsdwmc = xp.nextText();
                            fwqd.setJsdwmc(jsdwmc);
                        }else if ("lsm".equals(xp.getName())) {
                            String lsm = xp.nextText();
                            fwqd.setLsm(lsm);
                        }else if ("pmsl".equals(xp.getName())) {
                            String pmsl = xp.nextText();
                            fwqd.setPmsl(pmsl);
                        }else if ("bzs".equals(xp.getName())) {
                            String bzs = xp.nextText();
                            fwqd.setBzs(bzs);
                        }else if ("wzdm".equals(xp.getName())) {
                            String wzdm = xp.nextText();
                            fwqd.setWzdm(wzdm);
                        }else if ("zbqmc".equals(xp.getName())) {
                            String zbqmc = xp.nextText();
                            fwqd.setZbqmc(zbqmc);
                        }else if ("hxdm".equals(xp.getName())) {
                            String hxdm = xp.nextText();
                            fwqd.setHxdm(hxdm);
                        }else if ("hx".equals(xp.getName())) {
                            String hx = xp.nextText();
                            fwqd.setHx(hx);
                        }else if ("Jver".equals(xp.getName())) {
                            String jVer = xp.nextText();
                            fwqd.setJVer(jVer);
                            if(!jVer.equals(VersionUtils.getVersionName(this))){
                                msg.what = 5;
                                mHandleCount.sendMessage(msg);
                                return;
                            }
                        }
                        break;
                    case XmlPullParser.END_TAG:
                        if ("VIE__BZGL__FWQD".equals(xp.getName())) {
                            fwqd.setJydate(TimeUtil.getDate());
                            fwqdList.add(fwqd);
                            Boolean flag = fwqdService.insert(fwqd);
                            LogUtils.e("新增记录num---"+num+"all---"+all+"总量--"+bnp.getMax());
                            if(flag){
                                Message msgUp = new Message();
                                msgUp.what = 1;
                                mHandleCount.sendMessage(msgUp);
                            }else{
                                isSuccess = false;
                                return;
                            }
                        }
                        break;
                }
                //指针移动至下一个节点，并且获取它的事件类型
                type = xp.next();
            }
            LogUtils.e("读取xml结束"+TimeUtil.getDateLongNo());
            //showMessage("开始保存数据");
            if( fwqdList.size() ==0){
                msg.what = 4;
                mHandleCount.sendMessage(msg);
            }
        } catch (XmlPullParserException e1) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage("Err:"+ e1.getMessage());
        } catch (FileNotFoundException e1) {
            msg.what = 3;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage(UIUtil.getString(R.string.fail_null));
        } catch (IOException e1) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e1.getStackTrace();
            //showMessage("Err:"+ e1.getMessage());
        }catch (Exception e) {
            msg.what = 2;
            mHandleCount.sendMessage(msg);
            e.getStackTrace();
            //showMessage("Err:"+ e.getMessage());
        }finally {
        }
    }


    @Override
    public void onProgressChange(int current, int max) {
        if(current == max && isSuccess){
            showMessage(UIUtil.getString(R.string.import_success));
            String title = UIUtil.getString(R.string.system_note);
            String message = UIUtil.getString(R.string.delete_ysjh);
            if(parse){
                showDialog(title,message,new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        file.delete();//删除文件
                        //通知系统刷新文件
                        Intent intent = new Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE);
                        //通过文件的对象file的createNewFile()方法来创建文件
                        intent.setData(Uri.fromFile(file));
                        sendBroadcast(intent);

                    }
                },null);
            }
        }else if(!isSuccess){
            showMessage(UIUtil.getString(R.string.import_fail));
        }

    }

    private Handler mHandleCount = new Handler(){
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what){
                case 1://更新进度条
                    bnp.incrementProgressBy(1);
                    break;
                case 2://解析XML错误
                    showMessage("解析XML错误");
                    break;
                case 3://
                    showMessage(UIUtil.getString(R.string.fail_null));
                    break;
                case 4://
                    showMessage(UIUtil.getString(R.string.fail_data_null));
                    break;
                case 5://
                    showMessage("当前手持机版本过低，请下载最新的程序进行安装 <不需要卸载，直接覆盖安装>");
                    break;
            }
        }
    };

}
