package com.junmp.print.ui.matcheck.plan.maintain;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.view.View;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.presenter.BasePresenter;
import com.junmp.print.ui.BaseActivity;
import com.junmp.print.ui.fragment.DataFragment;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：运输计划维护页面
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainActivity extends BaseActivity {

    @BindView(R.id.tv_item_date_color)
    View dateView;

    @BindView(R.id.tv_item_date)
    TextView dateTv;

    @BindView(R.id.tv_item_unit_color)
    View unitView;

    @BindView(R.id.tv_item_unit)
    TextView unitTv;

    @BindView(R.id.maintainViewpager)
    ViewPager myViewPager;

    private List<Fragment> list;
    private MaintainFragmentPagerAdapter adapter;

    public void initView() {
        myViewPager.setOnPageChangeListener(new MyPagerChangeListener());

       //把Fragment添加到List集合里面
        list = new ArrayList<>();
        list.add(new DateFragment());
        list.add(new UnitFragment());
        adapter = new MaintainFragmentPagerAdapter(getSupportFragmentManager(), list);
        myViewPager.setAdapter(adapter);
        myViewPager.setCurrentItem(0);  //初始化显示第一个页面
    }

    @Override
    protected BasePresenter createPresenter() {
        return null;
    }

    @Override
    protected int getLayoutContentViewId() {
        return R.layout.activity_check_transferplan_maintain;
    }

    /**
     * 点击事件
     */
    @OnClick({R.id.tv_item_date,R.id.tv_item_unit})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.tv_item_date:
                myViewPager.setCurrentItem(0);
                dateTv.setTextColor(getResources().getColor(R.color.green));
                dateView.setBackgroundResource(R.color.green);
                unitTv.setTextColor(getResources().getColor(R.color.text_color));
                unitView.setBackgroundResource(R.color.float_transparent);
                break;
            case R.id.tv_item_unit:
                myViewPager.setCurrentItem(1);
                dateTv.setTextColor(getResources().getColor(R.color.text_color));
                dateView.setBackgroundResource(R.color.float_transparent);
                unitTv.setTextColor(getResources().getColor(R.color.green));
                unitView.setBackgroundResource(R.color.green);
                break;
        }
    }

    /**
     * 设置一个ViewPager的侦听事件，当左右滑动ViewPager时菜单栏被选中状态跟着改变
     *
     */
    public class MyPagerChangeListener implements ViewPager.OnPageChangeListener {

        @Override
        public void onPageScrollStateChanged(int arg0) {
        }

        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {
        }

        @Override
        public void onPageSelected(int arg0) {
            switch (arg0) {
                case 0:
                    dateTv.setTextColor(getResources().getColor(R.color.green));
                    dateView.setBackgroundResource(R.color.green);
                    unitTv.setTextColor(getResources().getColor(R.color.text_color));
                    unitView.setBackgroundResource(R.color.float_transparent);
                    break;
                case 1:
                    dateTv.setTextColor(getResources().getColor(R.color.text_color));
                    dateView.setBackgroundResource(R.color.float_transparent);
                    unitTv.setTextColor(getResources().getColor(R.color.green));
                    unitView.setBackgroundResource(R.color.green);
                    break;
            }
        }
    }

}

