package com.junmp.print.ui.matcheck.plan.maintain;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.dao.service.JpTabFwqdService;
import com.junmp.print.dao.service.JpTabFwqdjyService;
import com.junmp.print.iview.IUnitView;
import com.junmp.print.presenter.UnitPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.ui.matcheck.plan.maintain.unit.TfMaintainUnitActivity;
import com.junmp.print.util.UIUtil;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：接收单位查询页面
 * 版本：1.0
 * 日期：2018/4/25
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class UnitFragment extends BaseFragment<IUnitView, UnitPresenter> implements IUnitView {

    @BindView(R.id.unit_type_spinner)
    Spinner spinnerTypes;

    @BindView(R.id.unit_fwqd_spinner)
    Spinner fwqd_sp;

    @BindView(R.id.unit_ysjh_spinner)
    Spinner ysjhd_sp;

    @BindView(R.id.unit_jsdw_spinner)
    Spinner jsdw_sp;

    @BindView(R.id.bt_unit_search)
    TextView bt_unit_search;

    private List<String> data_list;
    private ArrayAdapter<String> arr_adapter;
    private ArrayAdapter<String> ysjhdh_adapter,jsdw_adapter,fwqd_adapter;
    private List<JpTabFwqd> listJsdw,listFwqd;

    String strYsjhbh = "",strJsdwdm = "",strdh = "",strCxTyperq = "查询全部";
    @Override
    protected int setView() {
        return R.layout.fragment_check_tfmaintain_unit;
    }

    JpTabFwqdService jpTabFwqdService = new JpTabFwqdService();
    JpTabFwqdjyService jpTabFwqdJyService = new JpTabFwqdjyService();

    @Override
    protected void init(View view) {
        //获取运输计划
        mPresenter.getCbox_ysjhValue();
        fwqd_sp.setOnItemSelectedListener(spnFwqdLis);
        jsdw_sp.setOnItemSelectedListener(spnJsdwLis);
        spinnerTypes.setOnItemSelectedListener(spnTypesLis);

    }

    @Override
    protected void intView(View view) {

    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

    }

    @OnClick({R.id.bt_unit_search})
    public void onViewClick(View view) {
        switch (view.getId()) {
            //跳转“接收单位查询结果”
            case R.id.bt_unit_search:
                search();
                break;
        }
    }

    private void search() {
        try{
            //if(!strJsdwdm.isEmpty()){
                Bundle bd = new Bundle();
                bd.putString("strYsjhbh",strYsjhbh);
                bd.putString("strJsdwdm",strJsdwdm);
                bd.putString("strdh",strdh);
                bd.putString("strCxTyperq",strCxTyperq);
                jumpToActivityTakeByAndClearTop(TfMaintainUnitActivity.class,bd);
            /*}else{
                showMessage(UIUtil.getString(R.string.jsdw_need));
            }*/
        }catch (Exception e){
            showMessage("Err :" + e.getMessage());
        }
    }

    @Override
    protected UnitPresenter createPresenter() {
        return new UnitPresenter(this);
    }

    /**
     * 展示运输计划*/
    @Override
    public void showYsjhdh(List<String> listYsjhdh) {
        if(listYsjhdh != null){

            ysjhd_sp.setOnItemSelectedListener(spnYsjhLis);
            //适配器
            ysjhdh_adapter= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, listYsjhdh);
            //设置样式
            ysjhdh_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            ysjhd_sp.setAdapter(ysjhdh_adapter);

            ysjhd_sp.setSelection(0,true);
        }
    }

    /**
     * 展示接收单位*/
    @Override
    public void showJsdw(List<JpTabFwqd> listJsdw) {
        if(listJsdw != null){
            this.listJsdw = listJsdw;
            List<String> listJsdwRe= new ArrayList<>();
            for(JpTabFwqd bean : listJsdw){
                if(bean.getJsdwmc() != null){
                    //显示名称
                    listJsdwRe.add(bean.getJsdwmc());
                }
            }
            //适配器
            jsdw_adapter = new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, listJsdwRe);
            //设置样式
            jsdw_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            jsdw_sp.setAdapter(jsdw_adapter);
            if(listJsdwRe.size() == 0){//接收单位为空时，发物清单也为空
                showFwqd(new ArrayList<>());
            }
            /*if(listJsdwRe.size() > 0){

            }else if(listJsdwRe.size() == 0 && listJsdw.size() > 0){

            }*/

        }

    }
    /**
     * 展示清单号*/
    @Override
    public void showFwqd(List<String> listQdh) {
        if(listQdh != null){
            //适配器
            fwqd_adapter= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, listQdh);
            //设置样式
            fwqd_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            //加载适配器
            fwqd_sp.setAdapter(fwqd_adapter);
        }

    }

    private Spinner.OnItemSelectedListener spnYsjhLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            strYsjhbh = parent.getSelectedItem().toString();
            strJsdwdm = "";
            strdh = "";
            mPresenter.getCbox_jsdwValue(strYsjhbh);

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
    private Spinner.OnItemSelectedListener spnJsdwLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            strJsdwdm = listJsdw.get(position).getJsdwdm().toString();
            if(strJsdwdm.equals("")){
                showFwqd(null);
            }else{
                mPresenter.getCXQdh(strYsjhbh,strJsdwdm);
            }

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
    private Spinner.OnItemSelectedListener spnFwqdLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            strdh = parent.getSelectedItem().toString();

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
    private Spinner.OnItemSelectedListener spnTypesLis = new Spinner.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView parent, View v, int position, long id)
        {
            strCxTyperq = parent.getSelectedItem().toString();

        }
        public void onNothingSelected(AdapterView parent)
        {
            //null
        }
    };
}
