package com.junmp.print.ui.matcheck.plan.maintain.unit;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.JpTabFwqd;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/4
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class TfMaintainUnitAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;

    public List<JpTabFwqd> data;
    public TfMaintainUnitAdapter(Context context, List<JpTabFwqd> data) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Object getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_tfmaintain_unit_item, null);

            holder = new ViewHolder();

            holder.tfUnit_swdwmc_tv = convertView.findViewById(R.id.tfUnit_swdwmc_tv);
            holder.tfUnit_zbqmc_tv = convertView.findViewById(R.id.tfUnit_zbqmc_tv);
            holder.tfUnit_hx_tv = convertView.findViewById(R.id.tfUnit_hx_tv);
            holder.tfUnit_pmsl_tv = convertView.findViewById(R.id.tfUnit_pmsl_tv);
            holder.tfUnit_jydate_tv = convertView.findViewById(R.id.tfUnit_jydate_tv);
            holder.tfUnit_item_ly = convertView.findViewById(R.id.tfUnit_item_ly);


            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        JpTabFwqd mInfo = data.get(position);

        if (mInfo != null) {
            holder.tfUnit_swdwmc_tv.setText(mInfo.getSwdwmc());
            holder.tfUnit_zbqmc_tv.setText(mInfo.getZbqmc());
            holder.tfUnit_hx_tv.setText(mInfo.getHx());
            holder.tfUnit_pmsl_tv.setText(String.valueOf(mInfo.getPmsl()));
            holder.tfUnit_jydate_tv.setText(mInfo.getJydate());
            if(mInfo.getIsOK().equals("N")){
                holder.tfUnit_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }
        }

        return convertView;
    }

    static class ViewHolder {

        TextView tfUnit_swdwmc_tv,tfUnit_zbqmc_tv,tfUnit_hx_tv,
                tfUnit_pmsl_tv,tfUnit_jydate_tv;
        LinearLayout tfUnit_item_ly;
    }

}

