package com.junmp.print.ui.matcheck.random;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.ProductEpcBean;
import com.junmp.print.ui.matcheck.out.outcheck.OutCheckListAdapter;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/6
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class CheckRandomTagsAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;
    private View.OnClickListener onClickListener;

    public List<ProductEpc> data;

    public CheckRandomTagsAdapter(Context context, List<ProductEpc> data,
                              View.OnClickListener onClickListener) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.onClickListener = onClickListener;
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public ProductEpc getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_random_tags_item, null);

            holder = new ViewHolder();

            holder.check_tags_xiangNo_tv = convertView.findViewById(R.id.check_tags_xiangNo_tv);
            holder.check_tags_wzhxname_tv = convertView.findViewById(R.id.check_tags_wzhxname_tv);
            holder.check_tags_strbqs_tv = convertView.findViewById(R.id.check_tags_strbqs_tv);
            holder.check_tags_dtScrq_tv = convertView.findViewById(R.id.check_tags_dtScrq_tv);
            holder.check_tags_strepc_tv = convertView.findViewById(R.id.check_tags_strepc_tv);
            holder.check_tags_noAndAll_tv = convertView.findViewById(R.id.check_tags_noAndAll_tv);
            holder.check_tags_item_ly = convertView.findViewById(R.id.check_tags_item_ly);

            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        ProductEpc pro = data.get(position);

        if (pro != null) {

            holder.check_tags_xiangNo_tv.setText(String.valueOf(pro.getiXangNo()));
            holder.check_tags_wzhxname_tv.setText(pro.getStrWzHXName());
            holder.check_tags_strbqs_tv.setText(pro.getStrBqs());
            holder.check_tags_dtScrq_tv.setText(TimeUtil.getDateStringShort(pro.getDtScrq()));
            holder.check_tags_strepc_tv.setText(pro.getStrEpc());
            holder.check_tags_noAndAll_tv.setText(pro.getStrZbAndAll());

            holder.check_tags_item_ly.setTag(position);
            holder.check_tags_item_ly.setOnClickListener(this.onClickListener);

            if(pro.getIbqs() < pro.getiZbAll() ){
                holder.check_tags_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
            }
            if(pro.getListIndex() == 1 && pro.getIbqs() == pro.getiZbAll()){
                holder.check_tags_item_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
            }
           /* if(pro.getIbqs() - 2 > 0){
                LinearLayout.LayoutParams para;
                para = (LinearLayout.LayoutParams) holder.check_tags_item_ly.getLayoutParams();
                para.height=(pro.getIbqs() - 2)*20 + 40;
                holder.check_tags_item_ly.setLayoutParams(para);
            }*/
        }

        return convertView;
    }

    static class ViewHolder {
        TextView check_tags_xiangNo_tv,check_tags_wzhxname_tv,check_tags_strbqs_tv,check_tags_dtScrq_tv,check_tags_strepc_tv,
                check_tags_noAndAll_tv;
        LinearLayout check_tags_item_ly;
    }
    public void updataView(int posi, ListView listView, ProductEpc pro) {
        int visibleFirstPosi = listView.getFirstVisiblePosition();
        int visibleLastPosi = listView.getLastVisiblePosition();
        if (posi >= visibleFirstPosi && posi <= visibleLastPosi) {
            View view = listView.getChildAt(posi - visibleFirstPosi);
            ViewHolder holder = (ViewHolder) view.getTag();

            if (pro != null) {

                holder.check_tags_xiangNo_tv.setText(String.valueOf(pro.getiXangNo()));
                holder.check_tags_wzhxname_tv.setText(pro.getStrWzHXName());
                holder.check_tags_strbqs_tv.setText(pro.getStrBqs());
                holder.check_tags_dtScrq_tv.setText(TimeUtil.getDateStringShort(pro.getDtScrq()));
                holder.check_tags_strepc_tv.setText(pro.getStrEpc());
                holder.check_tags_noAndAll_tv.setText(pro.getStrZbAndAll());

                holder.check_tags_item_ly.setTag(posi);
                holder.check_tags_item_ly.setOnClickListener(this.onClickListener);

                if(pro.getIbqs() < pro.getiZbAll() ){
                    holder.check_tags_item_ly.setBackgroundColor(UIUtil.getColor(R.color.red));
                }
                if(pro.getListIndex() == 1 && pro.getIbqs() == pro.getiZbAll()){
                    holder.check_tags_item_ly.setBackgroundColor(UIUtil.getColor(R.color.white));
                }
                data.set(posi, pro);
            }
        }
    }
}


