package com.junmp.print.ui.matcheck.repeat.scan;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.entity.Product_fwqd;
import com.junmp.print.ui.matcheck.random.CheckRandomAdapter;
import com.junmp.print.util.TimeUtil;
import com.junmp.print.util.UIUtil;

import java.util.List;

/**
 * <pre>
 * 描述：
 * 版本：1.0
 * 日期：2018/6/4
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class RepeatScanAdapter extends BaseAdapter {

    private Context mContext;

    private LayoutInflater mInflater;

    public  List<Product_fwqd>  data;
    public RepeatScanAdapter(Context context, List<Product_fwqd> data) {
        mContext = context;
        mInflater = LayoutInflater.from(mContext);
        this.data = data;
    }

    @Override
    public int getCount() {
        return (data != null ? data.size() : 0);
    }

    @Override
    public Product_fwqd getItem(int position) {
        return (data != null ? data.get(position) : null);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        if (convertView == null) {

            // 下拉项布局
            convertView = mInflater.inflate(R.layout.activity_check_repeat_scan_item, null);

            holder = new ViewHolder();

            holder.re_count_tv = convertView.findViewById(R.id.re_count_tv);
            holder.re_wzName_tv = convertView.findViewById(R.id.re_wzName_tv);
            holder.re_wzHxName_tv = convertView.findViewById(R.id.re_wzHxName_tv);
            holder.re_dtScrq_tv = convertView.findViewById(R.id.re_dtScrq_tv);
            holder.re_xiangNo_tv = convertView.findViewById(R.id.re_xiangNo_tv);
            holder.re_iNum_tv = convertView.findViewById(R.id.re_iNum_tv);
            holder.re_oldYsjhbh_tv = convertView.findViewById(R.id.re_oldYsjhbh_tv);
            holder.re_oldQdh_tv = convertView.findViewById(R.id.re_oldQdh_tv);


            convertView.setTag(holder);

        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        Product_fwqd mInfo = data.get(position);

        if (mInfo != null) {
            if(position == 0){
                holder.re_count_tv.setText("count");
                holder.re_iNum_tv.setText(mInfo.get_pro().getStrNum());
                holder.re_dtScrq_tv.setText(mInfo.get_pro().getStrScrq());
            }else{
                holder.re_count_tv.setText(String.valueOf(mInfo.getCount()));
                holder.re_iNum_tv.setText(String.valueOf(mInfo.get_pro().getiNum()));
                holder.re_dtScrq_tv.setText(TimeUtil.getDateStringShort(mInfo.get_pro().getDtScrq()));//yyyy-MM-dd
            }

            holder.re_wzName_tv.setText(mInfo.get_pro().getStrWzName());
            holder.re_wzHxName_tv.setText(mInfo.get_pro().getStrWzHXName());
            holder.re_xiangNo_tv.setText(mInfo.get_pro().getStrXiangNo());
            holder.re_oldYsjhbh_tv.setText(mInfo.getOldYsjhbh());
            holder.re_oldQdh_tv.setText(mInfo.getOldQdh());
        }

        return convertView;
    }

    static class ViewHolder {

        TextView re_count_tv,re_wzName_tv,re_wzHxName_tv,
                re_dtScrq_tv,re_xiangNo_tv,
                re_iNum_tv,re_oldYsjhbh_tv,re_oldQdh_tv;
    }

    public void updataView(int posi, ListView listView, Product_fwqd pro) {
        int visibleFirstPosi = listView.getFirstVisiblePosition();
        int visibleLastPosi = listView.getLastVisiblePosition();
        if (posi >= visibleFirstPosi && posi <= visibleLastPosi) {
            View view = listView.getChildAt(posi - visibleFirstPosi);
            ViewHolder holder = (ViewHolder) view.getTag();

            Product_fwqd mInfo = data.get(posi);

            if (mInfo != null) {
                holder.re_count_tv.setText(String.valueOf(mInfo.getCount()));
                holder.re_iNum_tv.setText(String.valueOf(mInfo.get_pro().getiNum()));
                holder.re_dtScrq_tv.setText(TimeUtil.getDateStringShort(mInfo.get_pro().getDtScrq()));//yyyy-MM-dd
                holder.re_wzName_tv.setText(mInfo.get_pro().getStrWzName());
                holder.re_wzHxName_tv.setText(mInfo.get_pro().getStrWzHXName());
                holder.re_xiangNo_tv.setText(mInfo.get_pro().getStrXiangNo());
                holder.re_oldYsjhbh_tv.setText(mInfo.getOldYsjhbh());
                holder.re_oldQdh_tv.setText(mInfo.getOldQdh());
            }
                data.set(posi, pro);
            }

    }

}
