package com.junmp.print.ui.set.checkmat;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.RadioButton;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.dao.entity.ProductEpc;
import com.junmp.print.dao.service.JpTabConfigService;
import com.junmp.print.iview.ICheckMatView;
import com.junmp.print.presenter.CheckMatPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.Util;
import com.uhf.scanlable.UHfData;

import java.util.Timer;
import java.util.TimerTask;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：校验设置
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class CheckMatFragment extends BaseFragment<ICheckMatView, CheckMatPresenter> implements ICheckMatView {

    /**
     * 数据库中物资代码 52位
     */
    @BindView(R.id.jy_wzdm_tv)
    TextView jy_wzdm_tv;

    /**
     * 数据库中物资代码
     */
    @BindView(R.id.jy_lsm_tv)
    TextView jy_lsm_tv;

    /**
     * 品名
     */
    @BindView(R.id.jy_wzname_tv)
    TextView jy_wzname_tv;

    /**
     * 型号
     */
    @BindView(R.id.jy_wzhxname_tv)
    TextView jy_wzhxname_tv;

    /**
     * 锁定校验物资
     */
    @BindView(R.id.cb_jy_sd)
    CheckBox cb_jy_sd;

    /**
     * 锁定号型
     */
    @BindView(R.id.cb_jy_sdhx)
    CheckBox cb_jy_sdhx;

    @BindView(R.id.bt_start_scan)
    RadioButton bt_start;

    @BindView(R.id.bt_stop_scan)
    RadioButton bt_end;

    JpTabConfigService jpTabConfigService = new JpTabConfigService();
    JpTabConfig jpTabConfig = new JpTabConfig();

    private boolean isInventory = false;
    private Handler mHandler;
    private boolean isCanceled = true;
    private static final int MSG_UPDATE_LISTVIEW = 0;
    private static final int SCAN_INTERVAL = 5;
    private Timer timer;

    @Override
    protected int setView() {
        return R.layout.fragment_set_check;
    }

    @Override
    protected void intView(View view) {

    }

    /**
     * key receiver
     */
    private long startTime = 0;
    private boolean keyUpFalg = true;
    private BroadcastReceiver keyReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            int keyCode = intent.getIntExtra("keyCode", 0);
            // H941
            if (keyCode == 0) {
                keyCode = intent.getIntExtra("keycode", 0);
            }
            boolean keyDown = intent.getBooleanExtra("keydown", false);
            if (keyUpFalg && keyDown && System.currentTimeMillis() - startTime > 500) {
                keyUpFalg = false;
                startTime = System.currentTimeMillis();
                if (keyCode == KeyEvent.KEYCODE_F3 && !isInventory) {
                    bt_start.performClick();
                }else if (keyCode == KeyEvent.KEYCODE_F3 && isInventory){
                    bt_end.performClick();
                }
                return;
            } else if (keyDown) {
                startTime = System.currentTimeMillis();
            } else {
                keyUpFalg = true;
            }

        }
    };

    @Override
    protected void init(View view) {
        getJyInfo();
        cb_jy_sdhx.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {

            @Override
            public void onCheckedChanged(CompoundButton checkBox, boolean isChecked) {
                cb_jy_sdhx.setChecked(isChecked);
                cb_jy_sd.setChecked(isChecked);
            }
        });

        UHfData.lsTagList.clear();
        UHfData.dtIndexMap.clear();

        /*IntentFilter filter = new IntentFilter();
        filter.addAction("android.rfid.FUN_KEY");
        getActivity().getApplicationContext().registerReceiver(keyReceiver, filter);*/

        mHandler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                if (isCanceled)
                    return;
                switch (msg.what) {
                    case MSG_UPDATE_LISTVIEW://数据更新
                        if (UHfData.lsTagList.size() > 0) {

                            tagMethod(UHfData.lsTagList.get(0).strEPC);
                        }else{
                            showMessage("未识别到任何标签！");
                        }

                        if (UHfData.mIsNew) {
                            new Thread(new Runnable() {

                                @Override
                                public void run() {
                                    if (!Util.soundfinished)
                                        Util.play(1, 0);
                                }
                            }).start();
                            UHfData.mIsNew = false;
                        }
                        break;
                    default:
                        break;
                }
                super.handleMessage(msg);
            }

        };
        Util.initSoundPool(getActivity());

    }

    @Override
    protected CheckMatPresenter createPresenter() {
            return new CheckMatPresenter(this);
    }

    @OnClick({R.id.bt_set_jyConfig,R.id.bt_start_scan,R.id.bt_stop_scan})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.bt_set_jyConfig:
                setJyInfo();
                break;
            case R.id.bt_start_scan:
                startScan();
                break;
            case R.id.bt_stop_scan:
                stopScan();
                break;
        }
    }

    private void getJyInfo() {
        try{
            //查询当前设置
            jpTabConfig = (JpTabConfig) jpTabConfigService.getConfigByid(UserCache.getId());
            //jy_wzdm_et.setText(jpTabConfig.getStrwzdm());
            jy_wzname_tv.setText(jpTabConfig.getStrwzname());
            jy_wzhxname_tv.setText(jpTabConfig.getStrwzhxname());
            cb_jy_sdhx.setChecked(jpTabConfig.getIsjysd().equals("Y")? true : false);
            cb_jy_sd.setChecked(jpTabConfig.getIsjysd().equals("Y")? true : false);
        }catch(Exception e){
            showMessage("Err:"+e.getMessage());
        }
    }

    /**
     *设置校验物资
     * */
    private void setJyInfo() {
        try{
            jpTabConfig.setStrwzdm(jy_lsm_tv.getText().toString());
            jpTabConfig.setStrwzname(jy_wzname_tv.getText().toString());
            jpTabConfig.setStrwzhxname(jy_wzhxname_tv.getText().toString());
            if(cb_jy_sd.isChecked())
                jpTabConfig.setIsjysd("Y");
            else
                jpTabConfig.setIsjysd("N");
            if(cb_jy_sdhx.isChecked())
                jpTabConfig.setIsjysdhx("Y");
            else
                jpTabConfig.setIsjysdhx("N");
            //修改设置
            boolean flag = jpTabConfigService.update(jpTabConfig);
            if(flag){
                //修改缓存的用户数据
                UserCache.save(jpTabConfig);
                showMessage(UIUtil.getString(R.string.set_success));
            }else{
                showMessage(UIUtil.getString(R.string.set_fail));
            }
        }catch(Exception e){
            showMessage("Err:"+e.getMessage());
        }
    }

    private void startScan() {
        try {
            showMessage(UIUtil.getString(R.string.start_scan));
            jy_lsm_tv.setText("");//10进制
            jy_wzdm_tv.setText("");
            jy_wzname_tv.setText("");
            jy_wzhxname_tv.setText("");
            UHfData.lsTagList.clear();
            UHfData.dtIndexMap.clear();
            isInventory = false;
            doTagInventory();
        } catch (Exception ex) {
            showMessage("ERR：" + ex.getMessage());
        }
    }

    private void stopScan() {
        try {
            showMessage(UIUtil.getString(R.string.stop_scan));
            doTagInventory();
            isInventory = false;
            if (UHfData.lsTagList.size() > 0) {
                tagMethod(UHfData.lsTagList.get(0).strEPC);
            }else{
                showMessage("未识别到任何标签！");
            }
        } catch (Exception ex) {
            showMessage("ERR：" + ex.getMessage());
        }
    }

    public void doTagInventory() {
        isInventory = !isInventory;
        if (timer == null && isInventory) {//盘点开始
            isCanceled = false;
            timer = new Timer();
            timer.schedule(new TimerTask() {
                @Override
                public void run() {
                    UHfData.Inventory_6c(255, 0);//0单标签，1多标签；255自动；是否盘存TID，0—否，1—是，值为1时盘存到的为标签的TID
//						UHfData.Inventory_6c_Mask((byte)0, 16, 0, UHfGetData.hexStringToBytes("E200"));
                    mHandler.removeMessages(MSG_UPDATE_LISTVIEW);
                    mHandler.sendEmptyMessage(MSG_UPDATE_LISTVIEW);
                }
            }, 0, SCAN_INTERVAL);
            showMessage("开始识别");
        } else {//盘点停止
            isCanceled = true;
            if (timer != null) {
                timer.cancel();
                timer = null;
                showMessage("结束识别");

            }
        }

        }


    private void tagMethod(String epc) {
           //待处理
           try{
               ProductEpc product = new ProductEpc();
               product.setStrEpc(epc);
               product.getInfoFormEpc();
               if(product.getStrTagType().equals("1") && product.getiTagLength() == 52){
                   product.getWZHXInfo();
                   String lsm = String.valueOf(product.getiWzLsm());
                   jy_lsm_tv.setText(lsm);//10进制
                   jy_wzdm_tv.setText(String.valueOf(product.getiWzNo()));
                   jy_wzname_tv.setText(product.getStrWzName());
                   jy_wzhxname_tv.setText(product.getStrWzHXName());
                   bt_end.performClick();
               }

           }catch (Exception e){

               showMessage("Err:"+e.getMessage());
           }

    }

    @Override
    public void onResume() {
        super.onResume();
        IntentFilter filter = new IntentFilter();
        filter.addAction("android.rfid.FUN_KEY");
        getActivity().getApplicationContext().registerReceiver(keyReceiver, filter);
    }


    @Override
    public void onStop() {
        super.onStop();
        mHandler.removeMessages(MSG_UPDATE_LISTVIEW);
        getActivity().getApplicationContext().unregisterReceiver(keyReceiver);

    }
}

