package com.junmp.print.ui.set.uhf;

import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.TextView;

import com.junmp.print.R;
import com.junmp.print.app.UserCache;
import com.junmp.print.dao.entity.JpTabConfig;
import com.junmp.print.dao.service.JpTabConfigService;
import com.junmp.print.iview.IUhfView;
import com.junmp.print.presenter.UhfPresenter;
import com.junmp.print.ui.BaseFragment;
import com.junmp.print.util.UIUtil;
import com.junmp.print.util.VersionUtils;
import com.uhf.scanlable.UHfData;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * <pre>
 * 描述：UHF设置
 * 版本：1.0
 * 日期：2018/4/26
 * 作者：wangq@junmp.com.cn
 * </pre>
 */

public class UhfFragment  extends BaseFragment<IUhfView, UhfPresenter> implements IUhfView {

    /**
     * 天线
     */
    @BindView(R.id.spinner_antPow)
    Spinner sp_antpow;

    /**
     * 软件版本号
     */
    @BindView(R.id.softVersion_tv)
    TextView softVersion_tv;

    /**
     * UHF版本
     */
    @BindView(R.id.firmVersion_tv)
    TextView firmVersion_tv;

    private ArrayAdapter<CharSequence>  arradp_pow;

    private Handler mHandler;

    private static final int MSG_SHOW_PROPERTIES = 0;

    @Override
    protected int setView() {
        return R.layout.fragment_set_uhf;
    }

    @Override
    protected UhfPresenter createPresenter() {
        return new UhfPresenter(this);
    }


    @Override
    protected void init(View view) {

        softVersion_tv.setText(VersionUtils.getVersionName(getActivity()));

        //适配器
        //arradp_pow= new ArrayAdapter<String>(getActivity(), android.R.layout.simple_spinner_item, R.array.Power_select);
        arradp_pow= ArrayAdapter.createFromResource(
                getActivity(), R.array.Power_select,
                android.R.layout.simple_spinner_item);
        //设置样式
        arradp_pow.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        //加载适配器
        sp_antpow.setAdapter(arradp_pow);

        /*int userAntPower = UserCache.getAntPower();
        sp_antpow.setSelection(userAntPower,true);*/

        mHandler = new Handler() {
            @Override
            public void handleMessage(Message msg) {
                // TODO Auto-generated method stub
                super.handleMessage(msg);
                switch (msg.what) {
                    case MSG_SHOW_PROPERTIES:
                        String Version = "V"
                                + String
                                .valueOf(UHfData.UHfGetData.getUhfVersion()[0])
                                + "."
                                + String.valueOf(UHfData.UHfGetData.getUhfVersion()[1]);
                        showResult(Version, UHfData.UHfGetData.getUhfdBm()[0]);
                        break;
                    default:
                        break;
                }
            }
        };

        getantpower();

    }

    @Override
    protected void intView(View view) {

    }

    @OnClick({R.id.bt_set_uhf,R.id.bt_get_uhf})
    public void onViewClick(View v) {
        switch (v.getId()) {
            case R.id.bt_set_uhf:
                setantpower();
                break;
            case R.id.bt_get_uhf:
                getantpower();
                break;
        }
    }

    //设置天线功率
    private void setantpower() {

        showMessage("");
        try {
            int setPowerData = sp_antpow.getSelectedItemPosition();
            //功率设置，0:表示成功。不等于0:表示失败
            int result = UHfData.UHfGetData.SetRfPower((byte) setPowerData);
            if (result == 0) {
                JpTabConfigService jpTabConfigService = new JpTabConfigService();
                JpTabConfig jpTabConfig = new JpTabConfig();
                jpTabConfig = (JpTabConfig) jpTabConfigService.getConfigByid(UserCache.getId());
                jpTabConfig.setNpower(setPowerData);
                boolean flag = jpTabConfigService.update(jpTabConfig);
                if(flag){
                    UserCache.saveAntPower(setPowerData);
                    showMessage("功率"+ setPowerData +UIUtil.getString(R.string.set_success));
                }else{
                    showMessage("功率["+ setPowerData +"]"+UIUtil.getString(R.string.set_fail));
                }
            } else {
                showMessage("功率["+ setPowerData +"]" +UIUtil.getString(R.string.set_fail));
            }
        } catch (Exception e) {
            showMessage( "Obtain Exception:" + e.getMessage());
            return;
        }
    }

    //获取天线功率
    private void getantpower() {
        showMessage("");
        try {
            UHfData.UHfGetData.GetUhfInfo();
            mHandler.removeMessages(MSG_SHOW_PROPERTIES);
            mHandler.sendEmptyMessage(MSG_SHOW_PROPERTIES);
        } catch (Exception e) {
            showMessage( "Obtain Exception:" + e.getMessage());
        }
    }

    private void showResult(String version,int powerdbm) {
        try {
            firmVersion_tv.setText(version.toUpperCase());
            sp_antpow.setSelection(powerdbm, true);
            showMessage(UIUtil.getString(R.string.read_success));
        } catch (Exception ex) {
            showMessage(ex.getMessage());
        }
    }
}

